/* $XConsortium: PopupMenu.c /main/cde1_maint/5 1995/10/11 18:11:37 montyb $ */
/*
 * Copyright (c) 1995, 1996, 1997, 1998, 1999 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#pragma ident   "@(#)PopupMenu.c 1.49 99/01/26 SMI; TSOL 2.x"

/*****************************************************************************
 *****************************************************************************
 **
 **   File:         PopupMenu.c
 **
 **   Project:      CDE
 **
 **   Description:  This file contains the functions for creating and managing
 **                 the main panel and subpanel popup menus.
 **
 **
 ****************************************************************************
 *****************************************************************************/

#ifdef TSOL
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>
#include <X11/keysymdef.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <sys/signal.h>
#endif /* TSOL */

#include <Xm/XmP.h>
#include <Xm/ManagerP.h>
#include <Xm/RowColumn.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>

#include <Dt/SharedProcs.h>

#ifdef TSOL
#include <bsm/auditwrite.h>
#include <bsm/audit_uevents.h>
#include <tsol/tsol.h>
#include <tsol/user.h>
#include <tsol/prof.h>   
#include <tsol/auth.h>   
#include <tsol/auth_names.h>   
#include <Dt/ModLabel.h>
#include "WmPanelP.h"
#include "WmCEvent.h"
#include "WmFunction.h"
#include "WmResNames.h"
#endif  /* TSOL */

#include "DataBaseLoad.h"
#include "WmGlobal.h"

#ifdef TSOL
extern Boolean F_Shutdown (String args, ClientData *pCD, XEvent *event);
extern void FreeFunctionArg (WmFunction wmFunc, void *pArg);
extern WmScreenData *pSD;

#define ManagedRoot(w) (!XFindContext (DISPLAY, (w), wmGD.screenContextType, \
(caddr_t *)&pSD) ? (SetActiveScreen (pSD), True) : \
(IsBackdropWindow (ACTIVE_PSD, (w))))

#define  IL_CANCEL	1  /* Flag to indicate between 2 dialog boxes */
#define  SL_CANCEL	2

	/*
	 * Define multi-line message strings.
	 * "L" messages are for logs "D" for dialogs
	 *
	 * The dialog messages contain new lines to separate
	 * the messages for display purposes.  The log messages
	 * don't contain the new lines.
	 */

#define	GRAB_MSG_1L "Query Window Label Failed. "\
"Another program may have grabbed the mouse.\n"

#define	GRAB_MSG_1D "Query Window Label Failed\n\n"\
"Another program may have grabbed the mouse.\n"

#define	GRAB_MSG_2L "Query Window Label Failed. "\
"Another program may have grabbed the keyboard.\n"

#define	GRAB_MSG_2D "Query Window Label Failed\n\n"\
"Another program may have grabbed the keyboard\n"

#define	GRAB_MSG_3L "Change Input IL Failed. "\
"Another program may have grabbed the mouse.\n"

#define	GRAB_MSG_3D "Change Input IL Failed\n\n"\
"Another program may have grabbed the mouse\n"

#define	GRAB_MSG_4L "Change Input IL Failed. "\
"Another program may have grabbed the keyboard.\n"

#define	GRAB_MSG_4D "Change Input IL Failed\n\n"\
"Another program may have grabbed the keyboard\n"

#define COMPLETE_WORK_MSG_1D "Please Complete your work in the Change "\
"Workspace SL dialog box\n"\
"You cannot get the front panel menu until you cancel or press Ok\n"\
"in the Change Workspace SL dialog box."

#define COMPLETE_WORK_MSG_2D "Please Complete your work in the Change "\
"Input IL dialog box\n"\
"You cannot get the front panel menu until you cancel or press Ok\n"\
"in the Change Input IL dialog box."

#define WKSPACE_SELECTION_MSG_1D "Error: "\
"You have selected root window as your workspace\n\n"\
"Please choose a valid window\n"

#endif /* TSOL */

#define POPUP_CHILDREN 7

#ifdef _NO_PROTO

extern void ToggleDefaultControl ();
extern void SwitchRenameLabel ();
extern Boolean CheckControlTypeFile ();
#ifdef TSOL
void ShowLabelFeedbackWindow ();
void PaintLabelFeedbackWindow ();
void ChangePasswdCB ();
void AllocateDeviceCB ();
void create_change_ws_shell ();
void create_change_iil_shell ();
void ChooseWindowCB ();
void PasswdPrompt();
void lbuild_destroy_handler();
#endif  /* TSOL */

#else  /*  _NO_PROTO  */

extern void ToggleDefaultControl (ControlData *, SubpanelData *, ControlData *);
extern void SwitchRenameLabel (Widget, BoxData *);
extern Boolean CheckControlTypeFile (ControlData *);
#ifdef TSOL
void ShowLabelFeedbackWindow (WmScreenData, XmString, XColor);
void PaintLabelFeedbackWindow (WmScreenData, XmString, XColor);
void ChangePasswdCB (Widget, XtPointer, XtPointer);
void AllocateDeviceCB (Widget, XtPointer, XtPointer);
void create_change_ws_shell (Widget parent);
void create_change_iil_shell (Widget parent);
void ChooseWindowCB (Widget, XtPointer, XtPointer);
void PasswdPrompt(WmUser *);
void lbuild_destroy_handler(void);
#endif  /* TSOL */

#endif  /*  _NO_PROTO  */

#ifdef TSOL
extern Widget role_dialog;
extern Widget role_msgbox;
extern Widget role_err_label;
extern Widget pass_text;

static int workspace_index = NULL;
static Window client_window;
static XmString lastlabel = 0;
static Bool resetWsButtons = True;
Auth_action auth_mode;
ModLabelData *dtwm_builder;
ModLabelData *iil_builder;
bslabel_t new_ws_sl;
int toggle_item_set;
uid_t AssumeRoleID;
#endif  /* TSOL */


/* popup dialog for Add A New Workspace */



/************************************************************************
 *
 *  ActionCB
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
ActionCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
ActionCB (Widget    w,
          XtPointer client_data,
          XtPointer call_data)

#endif /* _NO_PROTO */

{
   ControlData * control_data;
   int           control_type;

   int indx = (int) client_data;
   Arg args[1];


   XtSetArg (args[0], XmNuserData, &control_data);
   XtGetValues(w, args, 1);

   if (CheckControlTypeFile (control_data) == False)
      return;

   control_type = (int) (control_data->element_values[CONTROL_TYPE].parsed_value);		  

   if (control_type == CONTROL_FILE && !control_data->is_action)
   {
      DtActionArg * aap;

      aap = (DtActionArg *) XtCalloc(1,sizeof(DtActionArg));

      aap->argClass = DtACTION_FILE;

      aap->u.file.name = (char *)
               control_data->element_values[CONTROL_FILE_NAME].parsed_value;

#ifdef TSOL
      write_to_pipe(control_data->actions[indx]->action_name, 1, aap,
		wmGD.pActiveSD->pActiveWS->agent->fd);
#else /* TSOL */
      DtActionInvoke (control_data->icon,
	              control_data->actions[indx]->action_name,
                      aap, 1, NULL, NULL, NULL, 1, NULL, NULL);
#endif /* TSOL */

      XtFree ((char *) aap);
   }
   else
   {
#ifdef TSOL
      if ( strcmp("ExitSession", control_data->actions[indx]->action_name) == 0
        || strcmp("LockDisplay", control_data->actions[indx]->action_name) == 0
        || strcmp("Dtstyle", control_data->actions[indx]->action_name) == 0
        || strcmp("Dtdevmgr", control_data->actions[indx]->action_name) == 0
        || strcmp("SDTaccessx", control_data->actions[indx]->action_name) == 0)
	    {
                DtActionInvoke (control_data->icon,
                      control_data->actions[indx]->action_name,
                      control_data->actions[indx]->aap,
                      control_data->actions[indx]->count,
                      NULL, NULL, NULL, 1, NULL, NULL);
	    }else
	        write_to_pipe(control_data->actions[indx]->action_name,
		  control_data->actions[indx]->count,
		  control_data->actions[indx]->aap,
		  wmGD.pActiveSD->pActiveWS->agent->fd);
    #else /* TSOL */
      DtActionInvoke (control_data->icon,
                      control_data->actions[indx]->action_name,
                      control_data->actions[indx]->aap,
                      control_data->actions[indx]->count,
                      NULL, NULL, NULL, 1, NULL, NULL);
#endif /* TSOL */
   }
}


/************************************************************************
 *
 *  DeleteWorkspaceCB
 *	The callback function is called off of a menu pick to delete
 *	a specific workspace.  The function identifies the index of the
 *	workspace and calls the workspace manager API to perform the delete.
 *	All frontpanel UI processing is performed through a notification 
 *      callback issued by the workspace manager after a successful delete.
 *
 ************************************************************************/

#ifdef _NO_PROTO
void
DeleteWorkspaceCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
DeleteWorkspaceCB (Widget    w,
                   XtPointer client_data,
	           XtPointer call_data)

#endif /* _NO_PROTO */

{
   int delete_workspace = (int) client_data;
   SwitchData * switch_data;
   int i;
   
   /*  Look up the switch data to get the atom name of the workspace  */
   /*  to delete.                                                     */
   
   for (i = 0; i < panel.box_data_count; i++)
   {
      if (panel.box_data[i]->switch_data != NULL)
      {
         switch_data = panel.box_data[i]->switch_data;
         break;
      }
   }
   
   _DtWsmDeleteWorkspace (panel.shell, 
                          switch_data->atom_names[delete_workspace]);
}




/************************************************************************
 *
 *  RenameWorkspaceCB
 *	The callback function is called off of a menu pick to rename
 *	a specific workspace.  The function identifies the index of the
 *	workspace and calls SwitchRenameLabel() function to change the switch.
 *	button to a text widget for typing the new workspace name and setting.
 *	up the callback to accept the new name upon activation.
 *
 ************************************************************************/

#ifdef _NO_PROTO
void
RenameWorkspaceCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
RenameWorkspaceCB (Widget    w,
                   XtPointer client_data,
	           XtPointer call_data)

#endif /* _NO_PROTO */

{
   int rename_ws = (int) client_data;
   SwitchData * switch_data;
   int i;
   

   /*  Look up the switch data to get the atom name of the workspace  */
   /*  to delete.                                                     */
   
   for (i = 0; i < panel.box_data_count; i++)
   {
      if (panel.box_data[i]->switch_data != NULL)
      {
         switch_data = panel.box_data[i]->switch_data;
         break;
      }
   }
   
   SwitchRenameLabel (switch_data->buttons[rename_ws], panel.box_data[i]);
}






/************************************************************************
 *
 *  AddWorkspaceCB
 *	The callback function is called off of a menu pick.  It generates
 *	a new workspace name and calls the workspace manager API to 
 *	create the new workspace.  All frontpanel UI processing is 
 *	performed through a notification callback issued by the workspace
 *	manager after a successful add.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
AddWorkspaceCB (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;

#else
void
AddWorkspaceCB (Widget    w,
                XtPointer client_data,
                XtPointer call_data)

#endif /* _NO_PROTO */

{
   SwitchData * switch_data;
   char * switch_name;
   char * temp_name;

   int append;
   int i;
#ifdef TSOL
    int workspace_index = (int) client_data;
    WmScreenData *pSD = ACTIVE_PSD;
    WmWorkspaceData *pWS = NULL;

   /*  Get the beginning part of the new name  */
   
   temp_name = FPGETMESSAGE (82, 35, "New");
    if(workspace_index == -1){
	new_ws_sl = wmGD.session_minlabel;
	AssumeRoleID = WorkstationOwner;
    }else{
	pWS = &(pSD->pWS[workspace_index]);
	new_ws_sl = pWS->sl;
	AssumeRoleID = pWS->User->p.pw_uid;
	if(pWS->User->p.pw_uid != WorkstationOwner){
		temp_name = pWS->User->p.pw_name;
	}
    }
#else /* TSOL */

   /*  Get the beginning part of the new name  */
   
   temp_name = FPGETMESSAGE (82, 35, "New");
#endif /* TSOL */
   switch_name = XtMalloc (strlen (temp_name) + 5);
   strcpy (switch_name, temp_name);


   /*  Look up the switch data to get the atom name of the workspace  */
   /*  to delete.                                                     */
   
   for (i = 0; i < panel.box_data_count; i++)
   {
      if (panel.box_data[i]->switch_data != NULL)
      {
         switch_data = panel.box_data[i]->switch_data;
         break;
      }
   }
   

   /*  Generate a new title for the workspace.  It should be unique  */
   /*  from the existing title.                                      */

   append = 0;

   while (1)
   {
      Boolean good_name;
      
      good_name = True;
      append++;      

      for (i = 0; i < switch_data->switch_count; i++)
      {
         if (strcmp (switch_name, switch_data->switch_names[i]) == 0)
         {
            good_name = False;
            sprintf (switch_name, "%s_%d", temp_name, append);
	    continue;
         }
      }

      if (good_name)
      {
         _DtWsmCreateWorkspace (panel.shell, switch_name);
         break;
      }
   }

   XtFree(switch_name);
}


/************************************************************************
 *
 *  DeleteCancelCB
 *
 ************************************************************************/

#ifdef _NO_PROTO
static void
DeleteCancelCB( w, client_data, call_data )
        Widget w ;
        XtPointer client_data ;
        XtPointer call_data ;
#else
static void
DeleteCancelCB(
        Widget w,
        XtPointer client_data,
        XtPointer call_data )
#endif /* _NO_PROTO */
{
   XtUnmanageChild((Widget)client_data);
   XmUpdateDisplay((Widget)client_data);
   XtDestroyWidget((Widget)client_data);
}

#ifdef TSOL

/*--------------------------------------------------------------------
 * my_tsol_lbuild_cancel_cb - cancel callback for changing SL and
 *			     IL dialog boxes. There is another cancel
 *			     callback for this dialog box in libDtTsol,
 *			     which probably gets called first. 
 */
#ifdef _NO_PROTO
void
my_tsol_lbuild_cancel_cb (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;
#else
void
my_tsol_lbuild_cancel_cb(Widget    w,
                   	    XtPointer client_data,
	           	    XtPointer call_data)
#endif /* _NO_PROTO */
{

  SwitchData* switch_data;
  int         i;

  /* The actual cancel callback in DtTsol is not being
   * called before this routine. That routine sets the
   * show flag appropriately and does the GUI work of
   * popping down the dialog box. Due to the inconsistent
   * behavior of the order of calling multiple callbacks
   * on a widget, we set the flag here too.
   */
  if ((int)client_data == (int)IL_CANCEL)
	iil_builder->show = False;
  else if ((int)client_data == (int)SL_CANCEL)
	dtwm_builder->show = False;


  /* 
   * A user can open both the SL and IL dialog boxes
   * at the one time. We do not want the cancel from
   * one of these boxes to reset the Ws buttons, if the
   * other dialog box is still open. So we check for all
   * cases before we reset the buttons.
   */

  if (((int)client_data == (int)IL_CANCEL) &&
      !(dtwm_builder && dtwm_builder->show == True)) {
      /* SL dialog is up and IL dialog is being closed */
      resetWsButtons = True;
  }
  else if (((int)client_data == (int)SL_CANCEL) &&
           !(iil_builder && iil_builder->show == True)) {
      /* IL dialog is not up and SL dialog is being closed */
      resetWsButtons = True;
  }
  else if (!(dtwm_builder && (dtwm_builder->show == True)) &&
           !(iil_builder && (iil_builder->show == True))) {
      /*
       * Both SL and IL dialog boxes were closed by pressing cancel.
       * So none should be up. Safe to reset buttons.
       */
      resetWsButtons = True;
  }
  else {
      resetWsButtons = False;
  }

  /* Reset the ws buttons in front panel to be sensitive again.
     We made them insensitive in ChangeSLDialogCB to prevent changing
     the workspace while we are in the middle of changing an SL for
     another workspace.
   */
   switch_data = panel.box_data[0]->switch_data;

   if (resetWsButtons)
    {
     for (i=0; i < switch_data->switch_count; i++)
      {
       XtSetSensitive(switch_data->buttons[i],True);
      }
    }
}

/************************************************************************
 *
 *  ChangeSLDialogCB
 *	The callback function is called off of a menu pick.  It changes
 *	the sensitivity label of an existing workspace name.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
ChangeSLDialogCB (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;

#else
void
ChangeSLDialogCB (Widget    w,
                XtPointer client_data,
                XtPointer call_data)

#endif /* _NO_PROTO */

{
   SwitchData * switch_data;
   int i;
   char   ws_name[128];
   WmScreenData *pSD = ACTIVE_PSD;
   WmWorkspaceData *pWS = NULL;
   bslabel_t	*current_sl;

   char lbuild_title[200];
   char lbuild_name[200];
   
   workspace_index = (int) client_data;

   /*  Look up the switch data to get the atom name of the workspace  */
   /*  to relabel.                                                     */
   
   for (i = 0; i < panel.box_data_count; i++)
   {
   /*  See if the workspace name is being edited.  If so, call the  */
   /*  callback function to accept the changes.                     */
   
      if (panel.box_data[i]->switch_edit != NULL)
      {
         if (XtIsManaged (panel.box_data[i]->switch_edit))
         {
            Arg al[2];
            Widget switch_button;
	    
            XtSetArg (al[0], XmNuserData, &switch_button);
            XtGetValues (panel.box_data[i]->switch_edit, al, 1);
            SwitchRenameCB (panel.box_data[i]->switch_edit, 
	                    (XtPointer) switch_button, (XtPointer) NULL);
            XmProcessTraversal (w, XmTRAVERSE_CURRENT);
         }
      }
      if (panel.box_data[i]->switch_data != NULL)
      {

         switch_data = panel.box_data[i]->switch_data;
         break;
      }
   }

   strcpy(ws_name, switch_data->switch_names[workspace_index]);
    if (ws_name == NULL)
    {
        pWS= ACTIVE_WS;
    }
    else
    {
	pWS = &(pSD->pWS[workspace_index]);
    }
    /* check the role's password before creating a new xagent */

    if ((wmGD.wmRestarted == False)
       && (pWS->uid != WorkstationOwner)){
	if (pWS->User->saved_passwd == (char*)NULL){
	    PasswdPrompt(pWS->User);
	}
	if (pWS->User->saved_passwd == (char*)NULL
	   ||
	   (int)pWS->User->saved_passwd == -1){
	    pWS->User->saved_passwd = (char*)NULL;
	    return;
	}
    }
   
    if (pWS){

    strcpy(lbuild_title,
	GETMESSAGE(TSET, 1, "Workspace Manager: Change Workspace SL"));
    strcpy(lbuild_name, 
	GETMESSAGE(TSET, 2, "Workspace Name:"));
    strcat(lbuild_name, " ");
    strcat(lbuild_name, ws_name);
    current_sl = &pWS->sl;

    if (!dtwm_builder)
        create_change_ws_shell(wmGD.topLevelW1);

       /* user runs in the Multi level session */
       tsol_lbuild_set(dtwm_builder,
   	   LBUILD_SHOW,            TRUE,
	   LBUILD_LOWER_BOUND,	    &pWS->minlabel,
	   LBUILD_UPPER_BOUND,	    &pWS->clearance,
           LBUILD_TITLE,	    lbuild_title,
           LBUILD_USERFIELD,	    lbuild_name,
	   LBUILD_VALUE_SL,         current_sl,
   	   LBUILD_CHECK_AR,         pWS->User->do_accred_check,
   	   LBUILD_VIEW,             LBUILD_VIEW_INTERNAL,
	   NULL);

    }

  /* Make other ws buttons unsensitive, so user cannot launch another
   * Change SL dialog while working on the first one.
   */

   for (i=0; i < switch_data->switch_count; i++)
    {
     XtSetSensitive(switch_data->buttons[i],False);
    }
}

/***********************************************************************
 *
 *  Assume Role
 *
 *
 ***********************************************************************/
#ifdef _NO_PROTO
void
AssumeRoleCB (w, client_data, call_data)
		Widget w;
		XtPointer client_data;
		XtPointer call_data;
#else
void
AssumeRoleCB (  Widget    w,
               	XtPointer client_data,
               	XtPointer call_data)
#endif /* _NO_PROTO */
{
	Arg args[1];
	String temp;
	char *s1, *s2, *tmp_role;
	char *rolename;
	XmString xmstring;
	WmUser	*User;
	struct passwd	*p = NULL;
	userent_t	*u = NULL;
	int		i;
	
	XtSetArg(args[0], XmNlabelString, &xmstring);
	XtGetValues(w, args, 1);
	XmStringGetLtoR(xmstring, XmFONTLIST_DEFAULT_TAG, &temp);
	XmStringFree(xmstring);
	tmp_role = strdup(temp);

	s1 = strtok(tmp_role, " ");
	s2 = strtok(NULL, " ");
	rolename = malloc(strlen(s2) + 1);
	strcpy(rolename, s2);

	free(tmp_role);

	for(i = 0; i < wmGD.UserCount; i++){
		if(!strcmp(rolename, wmGD.User[i].p.pw_name)){
			User = &wmGD.User[i];
			p = &wmGD.User[i].p;
			u = wmGD.User[i].u;
			break;
		}
	}
	if ((User->saved_passwd == (char*)NULL) ||
	       ((int)User->saved_passwd == -1)) {
	    PasswdPrompt(User);
	    if (User->saved_passwd == (char*)NULL){
		return;
	    }
	}
	htobsl(u->labelmin, &new_ws_sl);

	/* fix for bug 4012212 */
	AssumeRoleID = p->pw_uid;
	
	AddRoleWorkspace(rolename);

}
    
void
PasswdPrompt(WmUser *User)
{
	static	Boolean first = True;
	Arg args[1];
	char *tmp_str; 
	char *role_str; 
	XmString xmstring;
	char temp[BUFSIZ];
	
	role_str = GETMESSAGE(TSET, 3, "Role:");
	tmp_str = malloc(strlen(User->p.pw_name) + strlen(role_str) + 2);
	sprintf(tmp_str, "%s %s\0", role_str, User->p.pw_name);
	xmstring = XmStringCreateLocalized(tmp_str);
	XtVaSetValues(role_msgbox,XmNmessageString,xmstring,NULL);
	XmStringFree(xmstring);
	free(tmp_str);

	if (first){
		first = False;
		ManageWindow (ACTIVE_PSD, XtWindow(role_dialog), 
			MANAGEW_CONFIRM_BOX);
	}else{
		first = True;
		ReManageDialog (ACTIVE_PSD, role_dialog);
	}

	if (XtIsManaged(role_err_label))
	  XtUnmanageChild(role_err_label);
	XmTextFieldSetString(pass_text, NULL);
	auth_mode.User = User;
	XtRealizeWidget(role_dialog);
	XmProcessTraversal(pass_text,XmTRAVERSE_CURRENT);

	/* Start with null, set to -1 by cancel callback */
	User->saved_passwd = (char*)NULL;
	while(User->saved_passwd == (char*)NULL
	      && (int)User->saved_passwd != -1){
		XEvent	event;
		Boolean dispatchEvent;

		XtAppNextEvent (wmGD.mwmAppContext, &event);
		dispatchEvent = True;
		if (ManagedRoot(event.xany.window))
		{
		    dispatchEvent = WmDispatchWsEvent (&event);
		} else {
		    dispatchEvent = WmDispatchClientEvent (&event);
		}

		if (dispatchEvent)
		{
		   /*
		    * Dispatch widget related event:
		    */

		    XtDispatchEvent (&event);
		}
        }

	if ((int)User->saved_passwd == -1)
	 {
	  User->saved_passwd = (char*)NULL;
	 }

	return;

}


/************************************************************************
 *
 *  QueryLabelCB
 *	The callback function is called off of a menu pick.  It lets
 *	the user pick a window for which the full label will be displayed.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
QueryLabelCB (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;

#else
void
QueryLabelCB (Widget    w,
                XtPointer client_data,
		XtPointer call_data)

#endif /* _NO_PROTO */
{

    int 	     screen = 0;
    int              status;
    Cursor           cursor;
    XEvent           event;
    Window           target_win = None;
    int              buttons = 0;
    int              x,y;
    int              i;
    Window           parent;
    Window           sub;
    int              new_x, new_y;
    int              offset;
    KeySym           keySym;

    Boolean          foundOne = False;
    int  clientNum, scr;
    WmFpEmbeddedClientData *pECD;
    WmScreenData     *pSD = NULL;
    ClientData	     *pCD = NULL;
    bilabel_t	     min_iil;

    String	    title, msg;

    XmString        str;
    XmFontList      fontList = ACTIVE_PSD->clientAppearance.fontList;
    extern ClientData *PanelCD;

    billow(&min_iil);
    str = (XmString)recompute_label(&ACTIVE_WS->sl, &min_iil, 
          DisplayWidth(DISPLAY, 0), fontList, ACTIVE_WS->uid);

    /* Make the target cursor */
    cursor = XCreateFontCursor (wmGD.display, XC_question_arrow);
    
    /* Grab the pointer using target cursor, letting it roam all over */
    for(i = 0; i < 3; i++){
	status = XGrabPointer (wmGD.display, RootWindow(wmGD.display, screen), 
			       False,
			       ButtonPressMask
			       | ButtonReleaseMask
			       | PointerMotionMask,
			       GrabModeAsync,
			       GrabModeAsync, None, cursor, CurrentTime);
	if (status == GrabSuccess)
		break;
	sleep(1);
    }
    if (status != GrabSuccess)
    {
        Warning (GETMESSAGE(TSET, 101, GRAB_MSG_1L));

	title = GETMESSAGE(TSET, 100, "Query Label Error");
	msg =  GETMESSAGE(TSET, 102, GRAB_MSG_1D);
	_DtMessage(XtParent(w), title, msg, NULL, NULL);

	return;
    }
    
    
    /* Grab the Keyboard so we can catch the ESC button press */
    status = XGrabKeyboard(wmGD.display, RootWindow(wmGD.display, screen), 
			   False,
                           GrabModeAsync, GrabModeAsync, CurrentTime);
    if (status != GrabSuccess)
    {
	XUngrabPointer (wmGD.display, CurrentTime);
        Warning (GETMESSAGE(TSET, 103, GRAB_MSG_2L)); 

	title = GETMESSAGE(TSET, 100, "Query Label Error");
	msg =  GETMESSAGE(TSET, 104, GRAB_MSG_2D);
	_DtMessage(XtParent(w), title, msg, NULL, NULL);

	return;


    }
    
    /* Let the user select a window... */
    while ((buttons == 0)) 
    {
	XtAppNextEvent(wmGD.mwmAppContext, &event);
	
	switch (event.type) 
	{
	  case ButtonPress:
	    if (target_win == None) 
	    {
		target_win = event.xbutton.subwindow; /* window selected */
		if (target_win == None)
		    target_win = RootWindow (wmGD.display, screen);
	    }
	    buttons++;
	    break;
	  case KeyPress:
	    /* Look for ESC key press and stop if we get one */
	    if (event.xkey.state & ShiftMask)
		offset = 1;
	    else
		offset = 0;
	    
	    keySym = XLookupKeysym((XKeyEvent *)&event, offset);
	    if (keySym == XK_Escape)
	    {
		XUngrabKeyboard (wmGD.display, CurrentTime);
		XUngrabPointer (wmGD.display, CurrentTime);
		return;
	    }
	case MotionNotify:
	    
	    target_win = event.xmotion.subwindow; /* window selected */
	    if (target_win == None)
		target_win = RootWindow (wmGD.display, screen);
	    
	    for (scr = 0; scr < wmGD.numScreens; scr++)
	    {
		if (wmGD.Screens[scr].managed &&
		    wmGD.Screens[scr].screen == screen)
		{
		    pSD = (&(wmGD.Screens[scr]));
		    break;
		}
	    }
	    if (!pSD)
	    {
		pSD=wmGD.pActiveSD;
	    }

	    /* check for subwindows */
	    parent = RootWindow (wmGD.display, screen);
	    x      = event.xmotion.x_root;
	    y      = event.xmotion.y_root;
	    
	    /*
	     * Determine if the top-level window that contains the pointer is a
	     * client managed by the window manager (there may be no window under
	     * the pointer or it may be an "override-redirect" window).
	     */

	    if ((event.xmotion.subwindow == None) ||
		(XFindContext (DISPLAY, event.xmotion.subwindow, wmGD.windowContextType,
		     (caddr_t *)&pCD)))
	    {
		/* no managed window under the pointer */
		pCD = NULL;
		while (!foundOne) 
		{
		    XTranslateCoordinates(wmGD.display, parent, target_win, x, y,
					  &new_x, &new_y, &sub);
		    if (!sub) 
		    {
			x = new_x;
			y = new_y;
			break;
		    }
		    else 
		    {
			pECD = (WmFpEmbeddedClientData *) pSD->pECD;
			for (clientNum = 0; clientNum < pSD->numEmbeddedClients;
			     clientNum++, pECD++)
			{
			    if ((pECD->pCD) &&
				(target_win == pECD->pCD->client))
			    {
				pCD = pECD->pCD;
				foundOne = True;
				break;
			    }
			}


			parent = target_win;
			target_win = sub;
			x = new_x;
			y = new_y;
		    }
		}
	    }
	    if(pCD){
	       if((pCD->clientClass != NULL) &&
		    (!strcmp( (char *)pCD->clientClass, (char *)"Dtwm")
		    || !strcmp( (char *)pCD->clientClass, (char *)"Iconbox")))
			ShowLabelFeedbackWindow(pSD, str, PanelCD->sl_color);
		else
		    ShowLabelFeedbackWindow(pSD, pCD->long_iconlabel, pCD->sl_color);
	    }else if (target_win == RootWindow (wmGD.display, screen)){
		ShowLabelFeedbackWindow(pSD, str, PanelCD->sl_color);
	    }else{
		XTsolResAttributes resattr;
		XmString	label;
		XColor		sl_color, unused;
		char		*colorname;

		XTSOLgetResAttributes(DISPLAY, target_win, IsWindow, &resattr);
	        label = (XmString)recompute_label(&resattr.sl, &resattr.il, 
		    DisplayWidth(DISPLAY, 0), fontList, ACTIVE_WS->uid);
                colorname = getlabelcolor(&resattr.sl);
                XAllocNamedColor(DISPLAY, DefaultColormap(DISPLAY,0),
                         colorname, &sl_color, &unused);

		ShowLabelFeedbackWindow(pSD, label, sl_color);
		XmStringFree(label);
	    }
	    break;
        }
	
	XtDispatchEvent(&event);
    } 
    
    XUngrabKeyboard (wmGD.display, CurrentTime);      /* Done with keyboard */
    XUngrabPointer (wmGD.display, CurrentTime);      /* Done with pointer */
    pSD=wmGD.pActiveSD;
    XmStringFree(lastlabel);
    lastlabel = NULL;
    HideFeedbackWindow(pSD);

}

#endif /* TSOL */
/************************************************************************
 *
 *  DeleteControlOkCB
 *	Called from the Ok button on the confimation dialog when a 
 *	control deletion is seleted from the popup menu.
 *
 ************************************************************************/

#ifdef _NO_PROTO

static void
DeleteControlOkCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else

static void
DeleteControlOkCB (Widget    w,
                   XtPointer client_data,
                   XtPointer call_data)

#endif /* _NO_PROTO */

{
   ControlData  * control_data;
   SubpanelData * subpanel_data;
   Arg args[1];


   /*  Extract the control data from the user data field of the  */
   /*  widget pointed to by client data.                         */
   
   XtSetArg (args[0], XmNuserData, &control_data);
   XtGetValues((Widget) client_data, args, 1);


   /*  Get the subpanel data for the control.  Check to see if the  */
   /*  control is a real subpanel control or the main panel copy.   */
   
   if (control_data->parent_type == SUBPANEL)
      subpanel_data = (SubpanelData *) control_data->parent_data;
   else
      subpanel_data = (SubpanelData *) control_data->subpanel_data;


   /*  Get rid of the dialog and call the funtion to delete the control  */

   XtUnmanageChild ((Widget) client_data);
   XmUpdateDisplay ((Widget) client_data);

   DeleteSubpanelControl (subpanel_data, control_data);

   XtDestroyWidget ((Widget) client_data);
}




/************************************************************************
 *
 *  DeleteSubpanelOkCB
 *
 ************************************************************************/

#ifdef _NO_PROTO
static void
DeleteSubpanelOkCB( w, client_data, call_data )
        Widget w ;
        XtPointer client_data ;
        XtPointer call_data ;
#else
static void
DeleteSubpanelOkCB(
        Widget w,
        XtPointer client_data,
        XtPointer call_data )
#endif /* _NO_PROTO */
{
   ControlData * control_data;
   Arg args[1];

   XtSetArg (args[0], XmNuserData, &control_data);
   XtGetValues((Widget)client_data, args, 1);

   XtUnmanageChild((Widget)client_data);
   XmUpdateDisplay((Widget)client_data);

   DeleteSubpanel(control_data);

   XtDestroyWidget((Widget)client_data);
}


/************************************************************************
 *
 *  DeleteControlCB
 *
 ************************************************************************/

#ifdef _NO_PROTO
void
DeleteControlCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
DeleteControlCB (Widget    w,
                 XtPointer client_data,
                 XtPointer call_data)

#endif /* _NO_PROTO */

{
    ControlData * control_data;
#ifndef	IBM_163763
    SubpanelData *subpanel_data;
#endif
    Widget dialog;
    String title, del_ctrl, ctrl_name, ctrl_label, del_msg, message;
    int indx = (int) client_data;
    Arg args[2];

    XtSetArg (args[0], XmNuserData, &control_data);
    XtGetValues (w, args, 1);

    del_ctrl = FPGETMESSAGE(82, 31, "Delete Control:");
    del_ctrl = XtNewString (del_ctrl);

    ctrl_label = (char *)
                control_data->element_values[CONTROL_LABEL].parsed_value;
    ctrl_name = (char *)
                   control_data->element_values[CONTROL_NAME].parsed_value;

    if (ctrl_label == NULL)
       ctrl_label = ctrl_name;

    if ((Boolean)control_data->element_values[CONTROL_LOCKED].parsed_value)
    {
       title = FPGETMESSAGE(82,1, "Workspace Manager - Delete Locked Control Error");
       title = XtNewString (title);

       del_msg = FPGETMESSAGE(82,5, "This control cannot be deleted because it is locked.");
       del_msg = XtNewString (del_msg);

       message = XtMalloc (sizeof(char) *
                           (strlen(del_ctrl) + strlen(ctrl_label) +
                            strlen(del_msg) + 4));

       sprintf(message, "%s %s\n\n%s", del_ctrl, ctrl_label, del_msg);

       _DtMessage (XtParent(w), title, message, NULL, NULL);

       XtFree (title);
       XtFree (del_ctrl);
       XtFree (del_msg);
       XtFree (message);
    }
    else
    {
       title = FPGETMESSAGE(82,2, "Workspace Manager - Delete Control");
       title = XtNewString (title);

#ifdef TSOL
       if ((!control_data->is_labeled) && (SessionFileNameLookup (ctrl_name, CONTROL, (char *) control_data->element_values[CONTROL_CONTAINER_NAME].parsed_value, SUBPANEL) == NULL))

#else /* TSOL */
       if (SessionFileNameLookup (ctrl_name, CONTROL, (char *) control_data->element_values[CONTROL_CONTAINER_NAME].parsed_value, SUBPANEL) == NULL)

#endif /* TSOL */
          del_msg = FPGETMESSAGE(82,32, "If you delete this control, you cannot restore it using\nthe \"Install Icon\" drop zone.\n\nYou can use \"RestorePanel\" in the Application Manager\nto put back this control at a later time.\n\nAre you sure you want to delete this control?");
       else
          del_msg = FPGETMESSAGE(82,6, "Are you sure you want to delete this control?");

       del_msg = XtNewString (del_msg);

       message = XtMalloc (sizeof(char) *
                           (strlen(del_ctrl) + strlen(ctrl_label) +
                            strlen(del_msg) + 4));

       sprintf(message, "%s %s\n\n%s", del_ctrl, ctrl_label, del_msg);

#ifndef	IBM_163763
       /*  Get the subpanel data for the control.  Check to see if the  */
       /*  control is a real subpanel control or the main panel copy.   */

       if (control_data->parent_type == SUBPANEL)
          subpanel_data = (SubpanelData *) control_data->parent_data;
       else
          subpanel_data = (SubpanelData *) control_data->subpanel_data;

       dialog = _DtMessageDialog(subpanel_data->shell,title,message,NULL,TRUE,
#else
       dialog = _DtMessageDialog(panel.shell, title, message, NULL, TRUE,
#endif
                           DeleteCancelCB, DeleteControlOkCB, NULL, NULL, False,
                           QUESTION_DIALOG);

       XtSetArg (args[0], XmNuserData, control_data);
       XtSetArg (args[1], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL);
       XtSetValues (dialog, args, 2);

       XtFree (title);
       XtFree (del_ctrl);
       XtFree (del_msg);
       XtFree (message);
    }

}




/************************************************************************
 *
 *  ToggleControlCB
 *      This callback initiates a subpanel control being toggled into
 *      the main panel.
 *
 ************************************************************************/

#ifdef _NO_PROTO
void
ToggleControlCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
ToggleControlCB (Widget    w,
                 XtPointer client_data,
                 XtPointer call_data)

#endif /* _NO_PROTO */

{
    SubpanelData * subpanel_data = (SubpanelData *) client_data;
    ControlData * control_data;
    int indx = (int) client_data;
    Arg args[1];

    XtSetArg (args[0], XmNuserData, &control_data);
    XtGetValues(w, args, 1);

    ToggleDefaultControl (subpanel_data->parent_control_data,
                          subpanel_data, control_data);
}




/************************************************************************
 *
 *  AddSubpanelCB
 *
 ************************************************************************/

#ifdef _NO_PROTO
void
AddSubpanelCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
AddSubpanelCB (Widget w,
               XtPointer client_data,
               XtPointer call_data)

#endif /* _NO_PROTO */

{
    ControlData * control_data;
    int indx = (int) client_data;
    Arg args[1];

    XtSetArg (args[0], XmNuserData, &control_data);
    XtGetValues(w, args, 1);

    AddSubpanel(control_data);
}




/************************************************************************
 *
 *  DeleteSubpanelCB
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
DeleteSubpanelCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
void
DeleteSubpanelCB (Widget    w,
                  XtPointer client_data,
                  XtPointer call_data)

#endif /* _NO_PROTO */

{
    ControlData * control_data;
    SubpanelData * subpanel_data;
    Widget dialog;
    String title, message, del_spanel, spanel_name, del_msg;
    Arg args[2];

    XtSetArg (args[0], XmNuserData, &control_data);
    XtGetValues(w, args, 1);

    subpanel_data = (SubpanelData *) control_data->subpanel_data;
    if (!subpanel_data)
	subpanel_data = (SubpanelData *) control_data->parent_data;

    del_spanel = FPGETMESSAGE(82, 33, "Delete Subpanel:");
    del_spanel = XtNewString (del_spanel);

    spanel_name = (char *)
                  subpanel_data->element_values[SUBPANEL_NAME].parsed_value;

    if ((Boolean)subpanel_data->element_values[SUBPANEL_LOCKED].parsed_value)
    {
       title = FPGETMESSAGE(82,3, "Workspace Manager - Delete Locked Subpanel Error");
       title = XtNewString (title);

       del_msg = FPGETMESSAGE(82,7, "This subpanel cannot be deleted because it is locked.");
       del_msg = XtNewString (del_msg);

       message = XtMalloc (sizeof(char) *
                           (strlen(del_spanel) + strlen(spanel_name) +
                            strlen(del_msg) + 4));

       sprintf(message, "%s %s\n\n%s", del_spanel, spanel_name, del_msg);

       _DtMessage (XtParent(w), title, message, NULL, NULL);

       XtFree (title);
       XtFree (del_spanel);
       XtFree (del_msg);
       XtFree (message);
    }
    else
    {
       title = FPGETMESSAGE(82,4, "Workspace Manager - Delete Subpanel");
       title = XtNewString (title);

       if (subpanel_data->control_data_count > 0)
       {
         if (SessionFileNameLookup (spanel_name, SUBPANEL, (char *)
            subpanel_data->element_values[SUBPANEL_CONTAINER_NAME].parsed_value,
            CONTROL) == NULL)
             del_msg = FPGETMESSAGE(82,34,
"If you delete this subpanel, you cannot restore all\nof the controls contained in the subpanel using the\n\"Install Icon\" drop zone.\n\nYou can use \"RestorePanel\" in the Application Manager\nto put back this subpanel and its controls at a later time.\n\nAre you sure you want to delete this subpanel?");
         else
             del_msg = FPGETMESSAGE(82,8, "This subpanel contains more than one control.\n\nAre you sure you want to delete this subpanel?");
       }
       else
          del_msg = FPGETMESSAGE(82,9, "Are you sure you want to delete this subpanel?");

       del_msg = XtNewString (del_msg);

       message = XtMalloc (sizeof(char) *
                           (strlen(del_spanel) + strlen(spanel_name) +
                            strlen(del_msg) + 4));

       sprintf(message, "%s %s\n\n%s", del_spanel, spanel_name, del_msg);

#ifndef	IBM_163763
       dialog = _DtMessageDialog(subpanel_data->shell,title,message,NULL,TRUE,
#else
       dialog = _DtMessageDialog(panel.shell, title, message, NULL, TRUE,
#endif
                          DeleteCancelCB, DeleteSubpanelOkCB, NULL, NULL, False,
                          QUESTION_DIALOG);

       XtSetArg (args[0], XmNuserData, control_data);
       XtSetArg (args[1], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL);
       XtSetValues(dialog, args, 2);

       XtFree (title);
       XtFree (del_spanel);
       XtFree (del_msg);
       XtFree (message);
    }
}





/************************************************************************
 *
 *  PostWorkspacePopupMenu
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
PostWorkspacePopupMenu (w, client_data, event)
Widget      w;
XtPointer   client_data;
XEvent    * event;
#else

void
PostWorkspacePopupMenu (Widget      w,
                        XtPointer   client_data,
                        XEvent    * event)

#endif /* _NO_PROTO */

{
   int i;
   BoxData * box_data;
   SwitchData * switch_data = NULL;
   XButtonEvent * b_event = (XButtonEvent *) event;
#ifdef TSOL
   String title, msg;
#endif /* TSOL */

   /* only use BMENU press events */

   if (b_event->button != wmGD.bMenuButton) return;

#ifdef TSOL
   if (dtwm_builder && dtwm_builder->show)
    {
     title = GETMESSAGE(TSET, 15, "Message!");
     msg =  GETMESSAGE(TSET, 16, COMPLETE_WORK_MSG_1D);
    _DtMessage(wmGD.topLevelW1, title, msg, NULL, NULL);
     return;
    }
   else if (iil_builder && iil_builder->show)
    {
     title = GETMESSAGE(TSET, 15, "Message!");
     msg =  GETMESSAGE(TSET, 17, COMPLETE_WORK_MSG_2D);
    _DtMessage(wmGD.topLevelW1, title, msg, NULL, NULL);
     return;
    }
#endif /* TSOL */


   for (i = 0; i < panel.box_data_count; i++)
   {
      box_data = panel.box_data[i];

      if (box_data->switch_data != NULL)
         switch_data = box_data->switch_data;
   }

   if (switch_data != NULL)
      XtManageChild(switch_data->popup_data->popup);
}




/************************************************************************
 *
 *  PostPopupMenu
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
PostPopupMenu (w, client_data, event)
Widget      w;
XtPointer   client_data;
XEvent    * event;

#else
void
PostPopupMenu (Widget      w,
               XtPointer   client_data,
               XEvent    * event)

#endif /* _NO_PROTO */

{
   XButtonEvent * b_event = (XButtonEvent *) event;

   /* only use BMENU press events */

   if (b_event->button != wmGD.bMenuButton) return;

   XtManageChild(panel.popup_data->popup);
}




/************************************************************************
 *
 *  GetBoxDataFromForm
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
static void
GetBoxDataFromForm (form, box_data_rtn)
Widget     form;
BoxData ** box_data_rtn;

#else
static void
GetBoxDataFromForm (Widget     form,
                    BoxData ** box_data_rtn)

#endif /* _NO_PROTO */

{
   BoxData * box_data;
   int i;

   for (i = 0; i < panel.box_data_count; i++)
   {
      box_data = panel.box_data[i];

      if (box_data == *box_data_rtn) continue;

      if (box_data->left_control_form == form ||
         box_data->right_control_form == form)
      {
         *box_data_rtn = box_data;
         break;
      }
   }
}




/************************************************************************
 *
 *  GetSubpanelDataFromForm
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
static void
GetSubpanelDataFromForm (form, subpanel_data_rtn)
Widget          form;
SubpanelData ** subpanel_data_rtn;

#else
static void
GetSubpanelDataFromForm (Widget          form,
                         SubpanelData ** subpanel_data_rtn)

#endif /* _NO_PROTO */

{
   BoxData * box_data;
   ControlData * control_data;
   SubpanelData * subpanel_data;
   int i, j;

   for (i = 0; i < panel.box_data_count; i++)
   {
      box_data = panel.box_data[i];

      for (j = 0; j < box_data->control_data_count; j++)
      {
         control_data = box_data->control_data[j];

         if (control_data->subpanel_data != NULL)
         {
            subpanel_data = control_data->subpanel_data;

            if (subpanel_data == *subpanel_data_rtn) continue;

            if (subpanel_data->form == form)
            {
               *subpanel_data_rtn = subpanel_data;
               break;
            }
         }
      }
   }
}





/************************************************************************
 *
 *  KeyMenuPosition
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
static void
KeyMenuPosition (popup, focus_widget)
Widget popup;
Widget focus_widget;

#else
static void
KeyMenuPosition (Widget popup, Widget focus_widget)

#endif /* _NO_PROTO */

{
   XButtonPressedEvent bevent;  /* synthetic button press event */
   Widget parent;
   Position root_x, root_y;
   Position x, y;
   Arg args[2];


   /* get the gadget's x and y */

   XtSetArg (args[0], XmNx, &x);
   XtSetArg (args[1], XmNy, &y);
   XtGetValues (focus_widget, args, 2);


   /* get the focus widget's parent since the focus widget is a gadget */

   parent = XtParent (focus_widget);


   /* get the root coordinates of the gadget */

   XtTranslateCoords (parent, x, y, &root_x, &root_y);


   /*  XmMenuPosition() only uses the root_x and root_y  */
   /*  of the event for positioning                      */

   bevent.x_root = root_x;
   bevent.y_root = root_y;


   /* set the menu positioning */

   XmMenuPosition (popup, &bevent);
}





/************************************************************************
 *
 *  GetMainControlData
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
static ControlData *
GetMainControlData (box_data, focus_widget)
BoxData * box_data;
Widget    focus_widget;

#else
static ControlData *
GetMainControlData (BoxData * box_data,
                    Widget    focus_widget)

#endif /* _NO_PROTO */

{
   int i;
   ControlData * control_data;
   Boolean found = False;

   for (i = 0; i < box_data->control_data_count; i++)
   {
      control_data = box_data->control_data[i];

      if (control_data->icon == focus_widget)
      {
         found = True;
         break;
      }
   }

   if (!found) return NULL;

   return (control_data);
}




/************************************************************************
 *
 *  GetSubpanelControlData
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
static ControlData *
GetSubpanelControlData (subpanel_data, focus_widget)
SubpanelData * subpanel_data;
Widget         focus_widget;

#else
static ControlData *
GetSubpanelControlData (SubpanelData * subpanel_data,
	                Widget         focus_widget)

#endif /* _NO_PROTO */

{
   int i;
   ControlData * control_data;
   Boolean found = False;

   if ( subpanel_data->dropzone == focus_widget )
      return NULL;

   if (subpanel_data->main_panel_icon_copy == focus_widget ||
       subpanel_data->parent_control_data->indicator == focus_widget)
   {
      return (subpanel_data->parent_control_data);
   }


   for (i = 0; i < subpanel_data->control_data_count; i++)
   {
      control_data = subpanel_data->control_data[i];
      if (control_data->icon == focus_widget ||
          control_data->indicator == focus_widget)
      {
         found = True;
         break;
      }
   }

   if (!found) return NULL;

   return (control_data);
}




/************************************************************************
 *
 *  SetupActionMenuItems
 *	Set up the action list for display in the popup menu for a 
 *	control.  This may require creating additional menu items is
 *	the action list for this control is greater that previously
 *	encountered or it may require umanaging menu item is there are
 *	less actions.
 *
 *	Inputs:
 *	   w: The parent of the menu items.
 *	   control_data: The control the menu is being set up for.
 *	   action_item: A pointer to the array of menu items for the actions.
 *	   action_count: A pointer to the total number of action items.
 *
 ************************************************************************/

#ifdef _NO_PROTO

static void
SetupActionMenuItems (w, control_data, popup_data, action_item, action_count)
Widget        w;
ControlData * control_data;
PopupData * popup_data;
Widget      ** action_item;
int         * action_count;

#else

static void
SetupActionMenuItems (Widget        w,
                      ControlData * control_data,
		      PopupData  * popup_data,
                      Widget      ** action_item,
                      int         * action_count)

#endif /* _NO_PROTO */

{
   XmString label_string;
   int i;
   int num_actions = 0;
   Arg args[5];
   int new_actions = 0;


   /*  Count the action list for the control in order to adjust  */
   /*  the number of action menu items within the menu.          */

   if (control_data != NULL)
      while (control_data->actions[num_actions] != NULL)
         num_actions++;

   /* This is a special case when there are no action items to create.
    * For e.g. the clock icon has no actions specified.
    */
   if (num_actions == 0)
    {
     XtUnmanageChild(popup_data->separator1);
     if (*action_count)
       for(i=0;i< (*action_count);i++)
         XtDestroyWidget((*action_item)[i]);
     *action_count = 0; 
     return;
    }

/* If we have less number of actions compared to last time 
   destroy those actions, so they don't show up in our list.
   Unmanaging would be better here, but when we need more actions
   we create new ones, rather than managing the unused old and then
   checking if we still need more action buttons and only then creating
   new actions. This logic is more complicated so we use create and
   destroy approach.
   Note:!!! we are not freeing the widget pointers from the action_item
   list when we destroy the widget. That gets taken care of when we do
   XtRealloc next time.
*/
  if(*action_count)
   {
     new_actions = num_actions - (*action_count);
     if (new_actions < 0)
      {
       new_actions = -1 * new_actions;
       for (i=num_actions; i<= new_actions; i++)
  	  XtDestroyWidget((*action_item)[i]);
      }
   }

  /* We have more action items then the last time, so create push buttons
   * for these new actions and put their pointers in action_item list.
   */
  if (num_actions > (*action_count) )
   {
      *action_item = (Widget *) XtRealloc((char *) *action_item,
					 sizeof(Widget* ) * num_actions);
      for (i = (*action_count); i < num_actions ; i++)
      {    
	  (*action_item)[i] = 
	     XmCreatePushButtonGadget (w, "action_button", args, 0);

          XtManageChild ((*action_item)[i]);
	  XtAddCallback ((*action_item)[i], XmNactivateCallback,
                         ActionCB, (XtPointer)i);
      }
   }
  /* update action_count for the next time we come here */
  (*action_count) = num_actions;

  /* Set the labels on the action items, and appropriate control data.
   * The logic used in this func is create new push buttons when there are more
   * actions items then the last time, and destroy push buttons if there
   * are less number of action items than last time. Do not create or destroy
   * pushbuttons if there are same number of action items compared to last
   * time. Once appropriate number of push buttons are there, then we worry
   * about the correct label and control data to put on them.
   */
  for (i = 0; i < num_actions; i++)
   {
      if (control_data->actions[i]->action_label != NULL)
         label_string = 
               XmStringCreateLocalized (control_data->actions[i]->action_label);
      else
         label_string = 
               XmStringCreateLocalized (control_data->actions[i]->action_name);
#ifdef TSOL
	if(control_data->is_labeled){
	/* append the SL and UID to the label_string */
	}
#endif /* TSOL */
     if((*action_item)[i])
      XtVaSetValues ((*action_item)[i], XmNlabelString, label_string,
				     XmNuserData, control_data,
		     NULL);

      XmStringFree (label_string);
   }

   if (num_actions > 0)
      XtManageChild(popup_data->separator1);
   else
      XtUnmanageChild(popup_data->separator1);

}

/************************************************************************
 *
 *  UpdateMainControlMenu
 *	Set up the label and the add/delete subpanel menu item for the
 *	popup menu.
 *
 *	Inputs:
 *	   control_data: The control overwhich the menu is being posted.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
UpdateMainControlMenu (control_data)
ControlData * control_data;

#else

static void
UpdateMainControlMenu (ControlData * control_data)

#endif /* _NO_PROTO */

{
   XmString   label_string;
   char     * mnemonic;
   char     * control_label;

   int control_type;
   Arg args[5];

   ElementValue * old_element_values;

   /*  Save element values of control then load values of default control */

   if (control_data->subpanel_data != NULL && 
	control_data != control_data->subpanel_data->default_control)
   {
	old_element_values = control_data->element_values;
	control_data->element_values = 
		control_data->subpanel_data->default_control->element_values;
   }

   /*  Set the title of the menu  */
   
   control_label =
	 (char *) control_data->element_values[CONTROL_LABEL].parsed_value;

   if (control_label == NULL)
      control_label = 
	       (char *) control_data->element_values[CONTROL_NAME].parsed_value;

   label_string = XmStringCreateLocalized (control_label);
   XtSetArg (args[0], XmNlabelString, label_string);
   XtSetValues (panel.popup_data->popup_title, args, 1);
   XmStringFree (label_string);


   /*  If the control is blank, remove the add/delete subpanel item.    */
   /*  Otherwise, if there is a subpanel, activate the delete subpanel  */
   /*  item.  Else activate the add subpanel item.                      */

   control_type = (int) control_data->element_values[CONTROL_TYPE].parsed_value;

   if (control_type != CONTROL_BLANK)
   {
      XtManageChild (panel.popup_data->modify_subpanel_item);

      if (control_data->subpanel_data == NULL)
      {
         if (panel.popup_data->subpanel_add_state != True)
         {
            label_string = 
	       XmStringCreateLocalized ((FPGETMESSAGE(82, 10, "Add Subpanel")));
            XtSetArg (args[0], XmNlabelString, label_string);
            mnemonic = ((char *)FPGETMESSAGE(82, 11, "A"));
            XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
            XtSetArg (args[2], XmNuserData, control_data);
            XtSetValues (panel.popup_data->modify_subpanel_item, args, 3);

            XmStringFree (label_string);

            XtRemoveCallback (panel.popup_data->modify_subpanel_item,
                              XmNactivateCallback, DeleteSubpanelCB, NULL);
            XtAddCallback (panel.popup_data->modify_subpanel_item,
                           XmNactivateCallback, AddSubpanelCB, NULL);

            panel.popup_data->subpanel_add_state = True;
         }
         else
         {
            XtSetArg (args[0], XmNuserData, control_data);
            XtSetValues (panel.popup_data->modify_subpanel_item, args, 1);
         }
      }
      else
      {
         if (panel.popup_data->subpanel_add_state == True)
         {
            label_string = 
	      XmStringCreateLocalized ((FPGETMESSAGE(82, 12, "Delete Subpanel")));
            XtSetArg (args[0], XmNlabelString, label_string);
            mnemonic = ((char *)FPGETMESSAGE(82, 13, "D"));
            XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
            XtSetArg (args[2], XmNuserData, control_data);
            XtSetValues (panel.popup_data->modify_subpanel_item, args, 3);

            XmStringFree (label_string);

            XtRemoveCallback (panel.popup_data->modify_subpanel_item,
                              XmNactivateCallback, AddSubpanelCB, NULL);
            XtAddCallback (panel.popup_data->modify_subpanel_item,
                           XmNactivateCallback, DeleteSubpanelCB, NULL);

            panel.popup_data->subpanel_add_state = False;
         }
         else
         {
            XtSetArg (args[0], XmNuserData, control_data);
            XtSetValues (panel.popup_data->modify_subpanel_item, args, 1);
         }
      }
   }
   else
   {
      XtUnmanageChild (panel.popup_data->modify_subpanel_item);
   }

   XtRemoveAllCallbacks (panel.popup_data->help_item, XmNactivateCallback);

   XtAddCallback(panel.popup_data->help_item, XmNactivateCallback,
	         ControlTopicHelpCB, (XtPointer)control_data);

   XtUnmanageChild (panel.popup_data->deinstall_item);
   XtUnmanageChild (panel.popup_data->toggle_item);

   /* Restore element values to control. */

   if (control_data->subpanel_data != NULL && 
	control_data != control_data->subpanel_data->default_control)
   {
	control_data->element_values = old_element_values;
   }
}





/************************************************************************
 *
 *  UpdateSubpanelControlMenu
 *	Set the elements of the popup menu for a subpanel control
 *	item to its proper values before it is made visible.
 *
 *	Inputs: 
 *	  subpanel_data:  The subpanel in which the menu is to be
 *                        posted.
 *
 *        control_data:  The control that the menu is being brought up for.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
UpdateSubpanelControlMenu (subpanel_data, control_data)
SubpanelData * subpanel_data;
ControlData  * control_data;

#else

static void
UpdateSubpanelControlMenu (SubpanelData * subpanel_data,
			   ControlData  * control_data)

#endif /* _NO_PROTO */

{
   XmString label_string;
   Arg args[5];
   char     * control_label = NULL;

   /*  Set the title of the menu  */
   
   if (control_data)
   {
      control_label =
	 (char *) control_data->element_values[CONTROL_LABEL].parsed_value;

      if (control_label == NULL)
         control_label = 
	       (char *) control_data->element_values[CONTROL_NAME].parsed_value;
   } 
   else
   {
      control_label = FPGETMESSAGE(82, 36, "Install Icon");
   }

   label_string = XmStringCreateLocalized (control_label);
   XtSetArg (args[0], XmNlabelString, label_string);
   XtSetValues (panel.popup_data->popup_title, args, 1);
   XmStringFree (label_string);


   /*  Set the sensitivity of the control deinstall and toggle menu item  */
   
   if (control_data == NULL)
   {
      XtSetSensitive (panel.popup_data->deinstall_item, False);
      XtSetSensitive (panel.popup_data->toggle_item, False);

      XtRemoveAllCallbacks (panel.popup_data->help_item, XmNactivateCallback);

      XtAddCallback(panel.popup_data->help_item, XmNactivateCallback,
		    GeneralTopicHelpCB, (XtPointer)INSTALL_ZONE);
   }
   else
   {
      XtSetSensitive (panel.popup_data->deinstall_item, True);
      XtSetArg (args[0], XmNuserData, control_data);
      XtSetValues(panel.popup_data->deinstall_item, args, 1);

      XtRemoveAllCallbacks (panel.popup_data->deinstall_item, 
                            XmNactivateCallback);

      XtAddCallback (panel.popup_data->deinstall_item, XmNactivateCallback,
                     DeleteControlCB, (XtPointer) NULL);

      if ( control_data ==  subpanel_data->default_control)
         XtSetSensitive (panel.popup_data->toggle_item, False);
      else
         XtSetSensitive (panel.popup_data->toggle_item, True);

      XtSetArg (args[0], XmNuserData, control_data);
      XtSetValues(panel.popup_data->toggle_item, args, 1);

      XtRemoveAllCallbacks (panel.popup_data->toggle_item,
                            XmNactivateCallback);

      XtAddCallback (panel.popup_data->toggle_item, XmNactivateCallback,
                     ToggleControlCB, (XtPointer) subpanel_data);

      XtRemoveAllCallbacks (panel.popup_data->help_item, XmNactivateCallback);

      XtAddCallback(panel.popup_data->help_item, XmNactivateCallback,
		    ControlTopicHelpCB, (XtPointer)control_data);
   }

   XtManageChild (panel.popup_data->deinstall_item);

   if ((Boolean) (subpanel_data->parent_control_data->
                  element_values[CONTROL_LOCKED].parsed_value) != True)
      XtManageChild (panel.popup_data->toggle_item);
   else
      XtUnmanageChild (panel.popup_data->toggle_item);
   
   XtUnmanageChild (panel.popup_data->modify_subpanel_item);
}




/************************************************************************
 *
 *  PopupMenu
 *	Callback function which updates the popup menu for main panel
 *	and subpanel controls before the menu is posted.
 *
 ************************************************************************/

#ifdef _NO_PROTO
static void
PopupMenu (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else

static void
PopupMenu (Widget    w,
           XtPointer client_data,
           XtPointer call_data)

#endif /* _NO_PROTO */

{
   XmAnyCallbackStruct * callback;
   XEvent * event;
   Widget form, focus_widget;
   XmManagerWidget mgr;
   SubpanelData * subpanel_data = NULL;
   ControlData * control_data;
   BoxData * box_data = NULL;
   XmString label_string;
   Arg args[5];
   int control_type, action_count = panel.popup_data->action_count;

   callback = (XmAnyCallbackStruct *) call_data;
   event = (XEvent *) callback->event;


   /*  Get the form where the menu was posted from.  */

   form = XmGetPostedFromWidget(w);

   XtSetArg (args[0], XmNuserData, &control_type);
   XtGetValues (form, args, 1);

   if (control_type == CONTROL)
   {
      GetBoxDataFromForm (form, &box_data);
      subpanel_data = NULL;
   }
   else if (control_type == SUBPANEL)
   {
      GetSubpanelDataFromForm (form, &subpanel_data);
      box_data = NULL;
   }

   if (event->type == ButtonPress)
   {
      /* Change to use new Xme function when porting to Motif 2.0 */
      /* Get gadget at x, y position */

      focus_widget = (Widget) _XmInputInGadget (form, event->xbutton.x,
					       event->xbutton.y);
      if (focus_widget == NULL)
         return;

      /* set the menu positioning */

      XmMenuPosition (panel.popup_data->popup, (XButtonPressedEvent *)event);
   }
   else
   {
      /* get the widget that has the traversal focus */

      focus_widget = XmGetFocusWidget (form);


      /* set the menu positioning for non button events */

      KeyMenuPosition (panel.popup_data->popup, focus_widget);
   }

   if (control_type == CONTROL)
   {
      control_data = GetMainControlData (box_data, focus_widget);

      /* Find the right subpanel data if main control is not default */
      /* control.						     */

      UpdateMainControlMenu (control_data);

      if (control_data->subpanel_data != NULL &&			
          control_data != control_data->subpanel_data->default_control)
      {
         subpanel_data = control_data->subpanel_data;
	 control_data = control_data->subpanel_data->default_control;
         control_data->subpanel_data = subpanel_data;
         UpdateMainControlMenu (control_data);
      }

      SetupActionMenuItems (w, control_data, panel.popup_data,
                            &(panel.popup_data->action_item), &action_count);

   }
   else if (control_type == SUBPANEL)
   {
      control_data = GetSubpanelControlData (subpanel_data, focus_widget);

      UpdateSubpanelControlMenu (subpanel_data, control_data);

      SetupActionMenuItems (w, control_data, panel.popup_data,
			    &(panel.popup_data->action_item), &action_count);
   }

   panel.popup_data->action_count = action_count;
}




/************************************************************************
 *
 *  CreatePopupMenu
 *
 ************************************************************************/

#ifdef _NO_PROTO

void
CreatePopupMenu (w)
Widget w;

#else

void
CreatePopupMenu (Widget w)

#endif /* _NO_PROTO */

{
   Widget children[20];
   char * mnemonic;
   Arg args[5];
   PopupData * popup_data;
   int i, child_num = 0;
   XmString label_string;

   popup_data = panel.popup_data = (PopupData *) XtMalloc(sizeof(PopupData));

   i = 0;
   XtSetArg (args[i], XmNwhichButton, wmGD.bMenuButton); i++;

   popup_data->popup = XmCreatePopupMenu(w, "FPPopup", args, i);

   popup_data->add_ws_item = NULL;

   XtAddCallback (popup_data->popup, XmNmapCallback, PopupMenu,
		  (XtPointer) NULL);

   popup_data->popup_title = children[child_num++] =
		 XmCreateLabelGadget(popup_data->popup, "title", NULL, 0);

   children[child_num++] = XmCreateSeparatorGadget(popup_data->popup,
						   "sep1", NULL, 0);
   children[child_num++] = XmCreateSeparatorGadget(popup_data->popup,
						   "sep2", NULL, 0);


   popup_data->action_count = 0;
   popup_data->action_item =  (Widget *) NULL; 

   popup_data->separator1 = children[child_num++] =
   		XmCreateSeparatorGadget (popup_data->popup, "sep3", NULL, 0);

   label_string =
           XmStringCreateLocalized((FPGETMESSAGE(82, 14, "Copy To Main Panel")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 15, "C"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->toggle_item = children[child_num] =
      XmCreatePushButtonGadget (popup_data->popup, "Toggle_Control", args, 2);
   XmStringFree (label_string);

   label_string = XmStringCreateLocalized((FPGETMESSAGE(82, 16, "Delete")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 17, "D"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->deinstall_item = children[child_num] =
	 XmCreatePushButtonGadget(popup_data->popup, "Delete_Control",
				  args, 2);
   XmStringFree (label_string);

   label_string =
              XmStringCreateLocalized ((FPGETMESSAGE(82, 10, "Add Subpanel")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 11, "A"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->modify_subpanel_item = children[child_num] =
	 XmCreatePushButtonGadget (popup_data->popup, "Add_Subpanel", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback, AddSubpanelCB,
			(XtPointer)NULL);
   popup_data->subpanel_add_state = True;

   popup_data->separator2 = children[child_num++] =
   		XmCreateSeparatorGadget(popup_data->popup, "sep4", NULL, 0);

   label_string = XmStringCreateLocalized ((FPGETMESSAGE(82, 18, "Help")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 19, "H"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->help_item = children[child_num++] =
   		XmCreatePushButtonGadget (popup_data->popup, "Help", args, 2);
   XmStringFree (label_string);

   XtManageChildren(children, child_num);
}




/************************************************************************
 *
 *  CreateActionButtons
 *     Show the the action menu items and hide workspace menu items since
 *     we are over a control.
 *
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
CreateActionButtons (w, switch_data, control_data)
Widget        w;
SwitchData *  switch_data;
ControlData * control_data;

#else

static void
CreateActionButtons (Widget        w,
	             SwitchData  * switch_data,
	             ControlData * control_data)

#endif /* _NO_PROTO */

{
    PopupData * popup_data = switch_data->popup_data;
    int action_count = popup_data->action_count;
    Arg args[1];
    XmString label_string;
    char     * control_label;

   /*  Set the title of the menu  */
   
    control_label =
	  (char *) control_data->element_values[CONTROL_LABEL].parsed_value;

    if (control_label == NULL)
       control_label = 
	       (char *) control_data->element_values[CONTROL_NAME].parsed_value;

    label_string = XmStringCreateLocalized (control_label);
    XtSetArg (args[0], XmNlabelString, label_string);
    XtSetValues (popup_data->popup_title, args, 1);
    XmStringFree (label_string);

   /* show actions items */
    SetupActionMenuItems(w, control_data, popup_data,
			 &(popup_data->action_item), &action_count);
    popup_data->action_count = action_count;

   /* hide add and delete workspace items */
    XtUnmanageChild(popup_data->add_ws_item);
    XtUnmanageChild(popup_data->delete_ws_item);
    XtUnmanageChild(popup_data->rename_ws_item);
#ifdef TSOL
   XtUnmanageChild (popup_data->set_sl);
#endif /* TSOL */

   /* reset the help callback to reflect switch control help */
    XtRemoveAllCallbacks (popup_data->help_item, XmNactivateCallback);
    XtAddCallback(popup_data->help_item, XmNactivateCallback,
                  ControlTopicHelpCB, control_data);
}





/************************************************************************
 *
 *  ShowWorkspaceItems
 *     Don't show the the action menu items since we are not over a control.
 *     Reset the activate callbacks with the latest data.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
ShowWorkspaceItems (switch_data, focus_widget)
SwitchData * switch_data;
Widget       focus_widget;

#else

static void
ShowWorkspaceItems (SwitchData * switch_data,
                           Widget       focus_widget)

#endif /* _NO_PROTO */

{
   PopupData * popup_data = switch_data->popup_data;
   int i;
   Arg args[1];
   XmString label_string;
   char     * control_label;
   char     * ws;
   char     * ws_name;
   char     * format;


   /* hide actions items */

   for (i = 0; i < popup_data->action_count; i++)
       XtUnmanageChild (popup_data->action_item[i]);

   /* show add and delete workspace items */

   XtManageChild (popup_data->add_ws_item);
   XtManageChild (popup_data->delete_ws_item);
   XtManageChild (popup_data->rename_ws_item);


   /* reset the activate callback to reflect current button index */

   XtRemoveAllCallbacks (popup_data->delete_ws_item, XmNactivateCallback);
   for (i = 0; i < switch_data->switch_count &&
               switch_data->buttons[i] != NULL; i++)
   {
      if (switch_data->buttons[i] == focus_widget) break;
   }


   /*  If we didn't find the switch button to post the menu for, it   */
   /*  must be in edit mode so the correct menu is the active switch  */

   if (i >= switch_data->switch_count)
      i = switch_data->active_switch;


   /*  Set the title of the menu  */
   
   format = strdup (FPGETMESSAGE(82, 20, "%1$s %2$s"));
   ws = strdup (FPGETMESSAGE(82, 21, "Workspace"));
   ws_name = switch_data->switch_names[i];

   control_label = XtMalloc (sizeof(char) * (strlen(ws) + strlen(ws_name) + 4));

   sprintf (control_label, format, ws, ws_name);
   free (format);
   free (ws);

   label_string = XmStringCreateLocalized (control_label);
   XtSetArg (args[0], XmNlabelString, label_string);
   XtSetValues (popup_data->popup_title, args, 1);
   XmStringFree (label_string);
   XtFree(control_label);

#ifdef TSOL
   /* reset the activate callback to reflect current button index */
   XtRemoveAllCallbacks (popup_data->add_ws_item, XmNactivateCallback);
   XtAddCallback (popup_data->add_ws_item, XmNactivateCallback,
	          AddWorkspaceCB, (XtPointer) i);
#endif TSOL

   XtAddCallback (popup_data->delete_ws_item, XmNactivateCallback,
	          DeleteWorkspaceCB, (XtPointer) i);
#ifdef TSOL
{

	WmScreenData	*pSD = ACTIVE_PSD;
	WmWorkspaceData *pWS;
	pWS = &(pSD->pWS[i]);

    if (blequal(&pWS->minlabel, &pWS->clearance)) {
       XtUnmanageChild(popup_data->set_sl);
    }else{
       XtManageChild (popup_data->set_sl);
       XtRemoveAllCallbacks (popup_data->set_sl, XmNactivateCallback);
       XtAddCallback (popup_data->set_sl, XmNactivateCallback,
		      ChangeSLDialogCB, (XtPointer) i);
    }
}
#endif /* TSOL */

   /* reset the activate callback to reflect current button index */
   XtRemoveAllCallbacks (popup_data->rename_ws_item, XmNactivateCallback);
   XtAddCallback (popup_data->rename_ws_item, XmNactivateCallback,
	          RenameWorkspaceCB, (XtPointer) i);

   /* reset the help callback to reflect switch button help */
   XtRemoveAllCallbacks (popup_data->help_item, XmNactivateCallback);
   XtAddCallback(popup_data->help_item, XmNactivateCallback,
                 GeneralTopicHelpCB, (XtPointer) SWITCH_BUTTON);

   XtManageChild(popup_data->separator1);
}




/************************************************************************
 *
 *  ShowPartialWorkspaceItems
 *     Don't show the delete workspace item since we are not over
 *     a workspace button and don't show the action menu items since we are
 *     not over a control.  Reset the activate callback with the latest data.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
ShowPartialWorkspaceItems (switch_data)
SwitchData * switch_data;

#else
static void
ShowPartialWorkspaceItems(SwitchData * switch_data)

#endif /* _NO_PROTO */

{
   PopupData * popup_data = switch_data->popup_data;
   int i;
   Arg args[1];
   XmString label_string;

#ifdef TSOL
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 20, "TP Menu"));
#endif /* TSOL */
   XtSetArg (args[0], XmNlabelString, label_string);
   XtSetValues (popup_data->popup_title, args, 1);
   XmStringFree (label_string);

   /* hide actions items */
   for (i = 0; i < popup_data->action_count; i++)
       XtUnmanageChild (popup_data->action_item[i]);

   /* show add workspace item */
   XtManageChild (popup_data->add_ws_item);

   /* hide delete and rename workspace items */
   XtUnmanageChild (popup_data->delete_ws_item);
   XtUnmanageChild (popup_data->rename_ws_item);
#ifdef TSOL
   XtUnmanageChild (popup_data->set_sl);
#endif /* TSOL */

   /* reset the help callback to reflect switch area help */
   XtRemoveAllCallbacks (popup_data->help_item, XmNactivateCallback);
   XtAddCallback(popup_data->help_item, XmNactivateCallback,
		 SwitchTopicHelpCB, (XtPointer)switch_data);

#ifdef TSOL
   /* reset the activate callback to reflect current button index */
   XtRemoveAllCallbacks (popup_data->add_ws_item, XmNactivateCallback);
   XtAddCallback (popup_data->add_ws_item, XmNactivateCallback,
                  AddWorkspaceCB, (XtPointer) -1);
#endif TSOL

   XtManageChild(popup_data->separator1);
}





/************************************************************************
 *
 *  GetSwitchDataFromForm
 *
 ************************************************************************/
 

#ifdef _NO_PROTO

static void
GetSwitchDataFromForm (form, switch_data_rtn)
Widget        form;
SwitchData ** switch_data_rtn;

#else

static void
GetSwitchDataFromForm (Widget        form,
                       SwitchData ** switch_data_rtn)

#endif /* _NO_PROTO */

{
   BoxData * box_data;
   int i;

   for (i = 0; i < panel.box_data_count; i++)
   {
      box_data = panel.box_data[i];

      if (box_data->switch_form == form)
      {
         *switch_data_rtn = box_data->switch_data;
         break;
      }
   }
}




/************************************************************************
 *
 *  GetSwtichControlData
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static ControlData *
GetSwitchControlData (switch_data, focus_widget)
SwitchData * switch_data;
Widget       focus_widget;

#else

static ControlData *
GetSwitchControlData (SwitchData * switch_data,
	              Widget       focus_widget)

#endif /* _NO_PROTO */

{
   int i;
   ControlData * control_data;
   Boolean found = False;

   for (i = 0; i < switch_data->control_data_count; i++)
   {
      control_data = switch_data->control_data[i];

      if (control_data->icon == focus_widget)
      {
         found = True;
         break;
      }
   }

   if (!found) return NULL;

   return (control_data);
}





/************************************************************************
 *
 *  WSPopupMenu
 *
 ************************************************************************/
 
#ifdef _NO_PROTO

static void
WSPopupMenu (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;

#else
static void
WSPopupMenu (Widget     w,
             XtPointer client_data,
             XtPointer call_data)

#endif /* _NO_PROTO */

{
   XmManagerWidget mgr = (XmManagerWidget) w;
   int num_children = mgr->composite.num_children;
   XmAnyCallbackStruct * callback;
   XEvent * event;
   Widget form, focus_widget;
   SwitchData * switch_data;
   ControlData * control_data = NULL;
   Boolean is_button = False;
   Position x, y;
   Arg args[2];
   int control_type;

   callback = (XmAnyCallbackStruct *) call_data;
   event = (XEvent *) callback->event;


   /* get the form where the menu was posted from */

   form = XmGetPostedFromWidget (w);

   GetSwitchDataFromForm (form, &switch_data);


   if (event->type == ButtonPress)
   {

     /*  Change to use new Xme function when porting to Motif 2.0  */
     /*  Get gadget at x, y position                               */

     focus_widget = (Widget) _XmInputInGadget (form, event->xbutton.x,
					       event->xbutton.y);

     if (focus_widget == NULL)
     {
        XtSetArg (args[0], XmNx, &x);
        XtSetArg (args[1], XmNy, &y);
        XtGetValues(switch_data->rc, args, 2);

        focus_widget = (Widget) _XmInputInGadget (switch_data->rc,
					          event->xbutton.x - x,
					          event->xbutton.y - y);
        is_button = True;
     }
     else
        control_data = GetSwitchControlData (switch_data, focus_widget);


     /* set the menu positioning */

     XmMenuPosition (switch_data->popup_data->popup,
                     (XButtonPressedEvent *) event);
   }
   else
   {
 
      /* get the widget that has the traversal focus */
  
      focus_widget = XmGetFocusWidget (form);

      control_data = GetSwitchControlData (switch_data, focus_widget);

      if (control_data == NULL)
         is_button = True;

      /* set the menu positioning for non button events */

      KeyMenuPosition (switch_data->popup_data->popup, focus_widget);
   }

   if (focus_widget != NULL)
   {
      if (is_button)
        /* The mouse is over a button in the switch area */
	 ShowWorkspaceItems (switch_data, focus_widget);
      else
      {
         if (control_data != NULL)
         {
            control_type =
		 (int) control_data->element_values[CONTROL_TYPE].parsed_value;

            if (control_type != CONTROL_BLANK)
              /* The mouse is over a control in the switch area */
	       CreateActionButtons (w, switch_data, control_data);
            else
              /* The mouse is over a blank control in the switch area */
               ShowPartialWorkspaceItems (switch_data);
         }
         else
         {
              /*
               * The mouse is over area other than the buttons and control
               * in the switch area
               */
      	       ShowPartialWorkspaceItems (switch_data);
         }
      }
   } 
   else
      /*
       * The mouse is over area other than the buttons and control
       * in the switch area
       */
      ShowPartialWorkspaceItems (switch_data);
}




/************************************************************************
 *
 *  CreateWorkspacePopupMenu
 *
 ************************************************************************/
 
 
#ifdef _NO_PROTO

void
CreateWorkspacePopupMenu (w, switch_data)
Widget        w;
SwitchData * switch_data;

#else
void
CreateWorkspacePopupMenu (Widget       w,
                          SwitchData * switch_data)

#endif /* _NO_PROTO */

{
#ifdef TSOL
   Widget children[50];
   char *tmpstr, *tmpstr2;
#else
   Widget children[20];
#endif /* TSOL */
   XmString label_string;
   char * mnemonic;
   Arg args[5];
   int i, child_num = 0;
   PopupData * popup_data;
   char		*s1, *s2;
   userent_t	*u_ent = wmGD.User[0].u;
   popup_data = (PopupData *) XtMalloc(sizeof(PopupData));

   i = 0;
   XtSetArg (args[i], XmNwhichButton, wmGD.bMenuButton); i++;

   popup_data->popup = XmCreatePopupMenu(w, "WSPopup", args, i);

   popup_data->deinstall_item = NULL;
   popup_data->toggle_item = NULL;
   popup_data->modify_subpanel_item = NULL;
   popup_data->subpanel_add_state = True;

   XtAddCallback(popup_data->popup, XmNmapCallback, WSPopupMenu,
		 (XtPointer) switch_data);

#ifdef TSOL
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 18, "TP Menu"));
#endif /* TSOL */
   XtSetArg (args[0], XmNlabelString, label_string);
   popup_data->popup_title = children[child_num++] =
   		XmCreateLabelGadget (popup_data->popup, "title", args, 1);
   XmStringFree (label_string);

   children[child_num++] = XmCreateSeparatorGadget (popup_data->popup, "sep1",
						    NULL, 0);
   children[child_num++] = XmCreateSeparatorGadget (popup_data->popup, "sep2",
						    NULL, 0);

#ifdef TSOL
   popup_data->action_item = (Widget *) XtMalloc(sizeof(Widget) * 15);
#endif /* TSOL */
   popup_data->action_count = 0;
   popup_data->action_item =  (Widget *) NULL; 

#ifdef TSOL
   for (i = 0; i < 15; i++)
#endif /* TSOL */
   label_string =
          XmStringCreateLocalized ((FPGETMESSAGE(82, 23, "Add Workspace")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 24, "A"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->add_ws_item = children[child_num] =
	 XmCreatePushButtonGadget (popup_data->popup, "Add_Workspace", args, 2);
   XmStringFree (label_string);

#ifdef TSOL
   XtAddCallback(children[child_num++], XmNactivateCallback, AddWorkspaceCB,
			(XtPointer) -1);
#endif /* TSOL */

   label_string = XmStringCreateLocalized((FPGETMESSAGE(82, 25, "Delete")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 26, "D"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->delete_ws_item = children[child_num] = 
 	                XmCreatePushButtonGadget (popup_data->popup,
						  "Delete_Workspace", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
	         DeleteWorkspaceCB, (XtPointer) 0);

   label_string = XmStringCreateLocalized((FPGETMESSAGE(82, 27, "Rename")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 28, "R"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->rename_ws_item = children[child_num] = 
 	                XmCreatePushButtonGadget (popup_data->popup,
						  "Rename_Workspace", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
	         RenameWorkspaceCB, (XtPointer) 0);

#ifdef TSOL 
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 35, "Change Workspace SL"));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)GETMESSAGE(TSET, 36, "W"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->set_sl = children[child_num] =
                        XmCreatePushButtonGadget (popup_data->popup,
                                                  "Set_Workspace_SL", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
                 ChangeSLDialogCB, (XtPointer) 0);
   /* dim if min == max for this uid...*/
/*   if(strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW))
      XtSetSensitive(popup_data->set_sl, False);
*/
#endif /* TSOL */

   popup_data->separator1 = children[child_num++] =
      XmCreateSeparatorGadget (popup_data->popup, "sep3", NULL, 0);

   popup_data->separator2 = NULL;



#ifdef TSOL 
   /******************** 1 **************************************************/
    s1 = s2 = strdup(u_ent->roles);
    while ((s1 = strtok(s1, ",")) != NULL) {
	    char *role_buf;
	    struct passwd	*p = NULL;
	    userent_t	*u = NULL;
	    int		i;

	    if (!strncmp(s1, "none", 4)){
		    child_num--;
		    break;
	    }
	    for(i = 0; i < wmGD.UserCount; i++){
		    if(!strcmp(s1, wmGD.User[i].p.pw_name)){
			    p = &wmGD.User[i].p;
			    u = wmGD.User[i].u;
			    break;
		    }
	    }
	    if(p == NULL){
		    WmUser	*User = &wmGD.User[wmGD.UserCount];
		    p = &User->p;
		    p = getpwnam_r(s1, p, User->pw_buffer, PW_BUF_LEN);
		    if ((u = User->u = getuserentbyname(s1, TSOL_DB_SRC_SWITCH)) == NULL) {
		      Widget dialog;
		      String title, err_msg, message;

		      title = GETMESSAGE(TSET, 18,
			  "Workspace Manager - User Identification");
		      err_msg = GETMESSAGE(TSET, 19, "The user or role has an incomplete set of attributes. \n See your system administrator.");

		      message = XtMalloc (strlen(s1) + strlen(err_msg) + 4);
		      sprintf(message, "%s \n\n%s", s1, err_msg);
		      _DtMessage(wmGD.topLevelW1, title, message, NULL, NULL);
		      s1 = NULL;
		      continue;

		    }else{
			int audit_flag = 0,
			    audit_ret = 0;

			User->saved_passwd = (char*)NULL;
			User->do_accred_check =
				chkauth(TSOL_AUTH_SYS_ACCRED_SET, u->name) == 1?
				    False : True;
			wmGD.UserCount++;
		    }
	    }

	    tmpstr = GETMESSAGE(TSET, 32, "Assume");
	    tmpstr2 = GETMESSAGE(TSET, 33, "Role");
	    role_buf = malloc(strlen(tmpstr) + strlen(tmpstr2) + strlen(s1) + 3);
	    sprintf(role_buf, "%s %s %s",tmpstr, s1, tmpstr2);
	    label_string = XmStringCreateLocalized(role_buf);
	    XtSetArg (args[0], XmNlabelString, label_string);
	    children[child_num] = XmCreatePushButtonGadget (popup_data->popup,
		    "Assume_Role", args, 1);
	    XmStringFree (label_string);
	    free(role_buf);
	    XtAddCallback(children[child_num++], XmNactivateCallback,
		     AssumeRoleCB, (XtPointer) 0);
	    s1 = NULL;
    }

    free(s2);
    children[child_num++] = XmCreateSeparatorGadget (popup_data->popup, "sep6",
		    NULL, 0);

   /******************** 2 **************************************************/
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 22, "Change Password"));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)GETMESSAGE(TSET, 23, "P"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->change_password = children[child_num] =
                        XmCreatePushButtonGadget (popup_data->popup,
                                                  "Change Password", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
                 ChangePasswdCB, (XtPointer) 0);


   /******************** 3 **************************************************/
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 24, "Allocate Device"));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)GETMESSAGE(TSET, 25, "l"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->change_password = children[child_num] =
                        XmCreatePushButtonGadget (popup_data->popup,
                                                  "Allocate Device", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
                 AllocateDeviceCB, (XtPointer) 0);

   /******************** 4 **************************************************/
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 26, "Query Window Label"));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)GETMESSAGE(TSET, 27, "Q"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->show_sl = children[child_num] =
                        XmCreatePushButtonGadget (popup_data->popup,
                                                  "Show_Workspace_SL", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
                 QueryLabelCB, (XtPointer) 0);

   /******************** 5 **************************************************/

       label_string = XmStringCreateLocalized(
	   GETMESSAGE(TSET, 28, "Change Input IL"));
       XtSetArg (args[0], XmNlabelString, label_string);
       mnemonic = ((char *)GETMESSAGE(TSET, 29, "I"));
       XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
       popup_data->show_iil = children[child_num] =
	    XmCreatePushButtonGadget (popup_data->popup,
	      "Change_Input_IL", args, 2);
       XmStringFree (label_string);

       XtAddCallback(children[child_num++], XmNactivateCallback,
	     ChooseWindowCB, (XtPointer) -1);

   /******************** 6 **************************************************/
   label_string = XmStringCreateLocalized(
       GETMESSAGE(TSET, 30, "Shut Down"));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)GETMESSAGE(TSET, 31, "S"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->shut_down = children[child_num] =
                        XmCreatePushButtonGadget (popup_data->popup,
                                                  "Shut_Down", args, 2);
   XmStringFree (label_string);

   XtAddCallback(children[child_num++], XmNactivateCallback,
                 F_Shutdown, (XtPointer) 0);

   children[child_num++] = XmCreateSeparatorGadget (popup_data->popup, "sep4",
						    NULL, 0);
#endif /* TSOL */



   label_string = XmStringCreateLocalized((FPGETMESSAGE(82, 29, "Help")));
   XtSetArg (args[0], XmNlabelString, label_string);
   mnemonic = ((char *)FPGETMESSAGE(82, 30, "H"));
   XtSetArg (args[1], XmNmnemonic, mnemonic[0]);
   popup_data->help_item = children[child_num++] =
   		XmCreatePushButtonGadget (popup_data->popup, "Help", args, 2);
   XmStringFree (label_string);

   XtManageChildren(children, child_num);

   switch_data->popup_data = popup_data;

#ifdef TSOL
   create_change_ws_shell(wmGD.topLevelW1);
   create_change_iil_shell(wmGD.topLevelW1);
#endif /* TSOL */
}

#ifdef TSOL
/***********************************************************************
 *
 *  Relabel an existing workspace
 *  We get here when user presses ok in Change SL dialog box.
 *  Actually the code goes to DtTsol's ModLabel.c where the
 *  actual ok callback is. When we created this dialog box
 *  we passed in the function pointer to call when ok is hit.
 *  Hence the original ok callback calls this function.
 *
 *
 ***********************************************************************/
	
static void get_lbuild_sl(Widget w, XtPointer client_data, XtPointer call_data)
{
	WmWorkspaceData	*pWS;
   	SwitchData * switch_data;
  	WmScreenData *pSD = ACTIVE_PSD;
   	int i;
	ModLabelData	*modLabel_data = (ModLabelData *) client_data;
		
	new_ws_sl = *(bslabel_t*) tsol_lbuild_get(
		modLabel_data, LBUILD_WORK_SL);

	tsol_lbuild_set(dtwm_builder,
		LBUILD_SHOW,            FALSE,
		NULL);

   /*  Look up the switch data to get the atom name of the workspace  */
   /*  to delete.                                                     */
   
   for (i = 0; i < panel.box_data_count; i++)
   {
      if (panel.box_data[i]->switch_data != NULL)
      {
         switch_data = panel.box_data[i]->switch_data;
         break;
      }
   }

	pWS = &(pSD->pWS[workspace_index]);
	/* audit Workspace SL change */
	if (audit_info.enabled && !blequal(&new_ws_sl, &(pWS->sl))) {
		 WmUser              *User = &wmGD.User[wmGD.UserCount];
		 auditwrite(AW_SUBJECT, audit_info.euid, audit_info.egid,
			    audit_info.ruid, audit_info.rgid, audit_info.auid,
			    audit_info.pid, audit_info.sid, &audit_info.tid,
			    AW_EVENTNUM, AUE_sl_change,
			    AW_SLABEL, &pWS->sl,	/* Old SL */
			    AW_SLABEL, &new_ws_sl,	/* new SL */
			    AW_RETURN, 0, 0,
			    AW_WRITE, AW_END);
		 if (User->do_accred_check) {
			 /* bypassing cred check, audit AUE_uath event as well */
			 auditwrite(AW_SUBJECT, audit_info.euid, audit_info.egid,
				    audit_info.ruid, audit_info.rgid, audit_info.auid,
				    audit_info.pid, audit_info.sid, &audit_info.tid,
				    AW_EVENTNUM, AUE_uauth,
				    AW_TEXT, auth_to_str(TSOL_AUTH_SYS_ACCRED_SET),
				    AW_RETURN, 0, 0,
				    AW_WRITE, AW_END);
		 }
	}
	pWS->sl = new_ws_sl;

	/* fix for bug 4012212 */
	AssumeRoleID = pWS->uid;

	SwitchButtonCreate(switch_data, True, workspace_index, pSD->pWS);
	ConnectToAgent(pWS, True);	
	SetTsolWorkspace(pWS);

  /* Reset the ws buttons in front panel to be sensitive again.
     We made them insensitive in ChangeSLDialogCB to prevent changing
     the workspace while we are in the middle of changing an SL for
     another workspace.
   */
   for (i=0; i < switch_data->switch_count; i++)
    {
     XtSetSensitive(switch_data->buttons[i],True);
    }
}


/***********************************************************************
 *
 *  Change Input IL
 *  We get here when user presses ok in Change IL dialog box.
 *  Actually the code goes to DtTsol's ModLabel.c where the
 *  actual ok callback is. When we created this dialog box
 *  we passed in the function pointer to call when ok is hit.
 *  Hence the original ok callback calls this function.
 *
 ***********************************************************************/
static void get_lbuild_il(Widget w, XtPointer client_data, XtPointer call_data)
{
	ModLabelData	*modLabel_data = (ModLabelData *) client_data;
	ClientData	*pCD;
	bilabel_t       new_input_il;
        int 		i;
   	SwitchData 	*switch_data;
		
	new_input_il = *(bilabel_t*) tsol_lbuild_get(
		modLabel_data, LBUILD_WORK_IL);
	tsol_lbuild_set(iil_builder,
		LBUILD_SHOW,            FALSE,
		NULL);

	XTSOLsetWindowIIL( DISPLAY, client_window, &new_input_il);
	if(!XFindContext(DISPLAY, client_window, wmGD.windowContextType,
			 (caddr_t *)&pCD)) 
	{
		/* audit change of IIL */
		if (audit_info.enabled && !bilequal(&new_input_il, &pCD->iil)) {
			auditwrite(AW_SUBJECT, audit_info.euid, audit_info.egid,
				   audit_info.ruid, audit_info.rgid, audit_info.auid,
				   audit_info.pid, audit_info.sid, &audit_info.tid,
				   AW_EVENTNUM, AUE_iil_change,
				   AW_ILABEL, &pCD->iil,	/* old iil */
				   AW_ILABEL, &new_input_il,	/* new iil */
				   AW_RETURN, 0, 0,
				   AW_WRITE, AW_END);
		}
		pCD->iil = new_input_il;
	}

  /* Reset the ws buttons in front panel to be sensitive again.
     We made them insensitive in ChangeSLDialogCB to prevent changing
     the workspace while we are in the middle of changing an SL for
     another workspace.
   */
   switch_data = panel.box_data[0]->switch_data;
   for (i=0; i < switch_data->switch_count; i++)
    {
     XtSetSensitive(switch_data->buttons[i],True);
    }
}	

void
lbuild_destroy_handler()
{
    SwitchData* switch_data;
    register int i = 0;

    switch_data = panel.box_data[0]->switch_data;
    for (i=0; i < switch_data->switch_count; i++)
    {
        XtSetSensitive(switch_data->buttons[i],True);
    }
    resetWsButtons = True;
    if (iil_builder && iil_builder->show) {
        tsol_lbuild_destroy(iil_builder);
        iil_builder = (ModLabelDataPtr)NULL;
    }
    else if (dtwm_builder && dtwm_builder->show) {
        tsol_lbuild_destroy(dtwm_builder);
        dtwm_builder = (ModLabelDataPtr)NULL;
    }
}

void create_change_ws_shell(Widget parent)
{
	char *s1;

	s1 = GETMESSAGE(TSET, 1, "Workspace Manager: Change Workspace SL");
	dtwm_builder =
        (ModLabelData *)tsol_lbuild_create(parent, get_lbuild_sl,
                                          LBUILD_MODE,  LBUILD_MODE_SL,
                                          LBUILD_TITLE, s1,
                                          LBUILD_X,     200,
                                          LBUILD_Y,     100,
                                          NULL);

	tsol_lbuild_set(dtwm_builder,
	    LBUILD_CANCEL_HANDLER,	my_tsol_lbuild_cancel_cb,
	    LBUILD_CANCEL_DATA,		(XtPointer)SL_CANCEL,
	    NULL);
}

void create_change_iil_shell(Widget parent)
{
	char *s1;

	s1 = GETMESSAGE(TSET, 42, "Workspace Manager: Change Input IL");
	iil_builder =
        (ModLabelData *)tsol_lbuild_create(parent, get_lbuild_il,
                                          LBUILD_MODE,   LBUILD_MODE_IL,
                                          LBUILD_TITLE,  s1,
                                          LBUILD_X,      200,
                                          LBUILD_Y,      100,
                                          NULL);

	tsol_lbuild_set(iil_builder,
	    LBUILD_CANCEL_HANDLER,	my_tsol_lbuild_cancel_cb,
	    LBUILD_CANCEL_DATA,		(XtPointer)IL_CANCEL,
	    NULL);
}

/************************************************************************
 *
 *  ChooseWindowCB
 *	The callback function is called off of a menu pick.  It changes
 *	the sensitivity label of an existing workspace name.
 *
 ************************************************************************/
 
#ifdef _NO_PROTO
void
ChooseWindowCB (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;

#else
void
ChooseWindowCB (Widget    w,
                XtPointer client_data,
                XtPointer call_data)

#endif /* _NO_PROTO */

{
    char lbuild_title[200];
    char lbuild_name[200];
    WmUser	     *User;
    int		     labelview;
    int 	     screen = 0;
    int              status;
    Cursor           cursor;
    XEvent           event;
    Window           target_win = None;
    int              buttons = 0;
    int              x,y;
    int              i;
    Window           parent;
    Window           sub;
    int              new_x, new_y;
    int              offset;
    KeySym           keySym;
    SwitchData	     *switch_data;

    Boolean          foundOne = False;
    int  clientNum, scr;
    WmFpEmbeddedClientData *pECD;
    WmScreenData     *pSD = NULL;
    ClientData	     *pCD = NULL;
    bilabel_t		min_iil;
    XTsolResAttributes resattr;
    String           title, msg;

    /* Make the target cursor */
    cursor = XCreateFontCursor (wmGD.display, XC_question_arrow);
    
    /* Grab the pointer using target cursor, letting it roam all over */
    for(i = 0; i < 3; i++){
	status = XGrabPointer (wmGD.display, RootWindow(wmGD.display, screen), 
			       False,
			       ButtonPressMask
			       | ButtonReleaseMask,
			       GrabModeAsync,
			       GrabModeAsync, None, cursor, CurrentTime);
	if (status == GrabSuccess)
		break;
	sleep(1);
    }
    if (status != GrabSuccess)
    {
        Warning (GETMESSAGE(TSET, 111, GRAB_MSG_3L)); 

	title = GETMESSAGE(TSET, 110, "Change Input IL Error");
	msg =  GETMESSAGE(TSET, 112, GRAB_MSG_3D);
	_DtMessage(XtParent(w), title, msg, NULL, NULL);

	return;
    }
    
    
    /* Grab the Keyboard so we can catch the ESC button press */
    status = XGrabKeyboard(wmGD.display, RootWindow(wmGD.display, screen), 
			   False,
                           GrabModeAsync, GrabModeAsync, CurrentTime);
    if (status != GrabSuccess)
    {
	XUngrabPointer (wmGD.display, CurrentTime);
        Warning (GETMESSAGE(TSET, 113, GRAB_MSG_4L)); 

	title = GETMESSAGE(TSET, 110, "Change Input IL Error");
	msg =  GETMESSAGE(TSET, 114, GRAB_MSG_4D);
	_DtMessage(XtParent(w), title, msg, NULL, NULL);

	return;
    }
    
    /* Let the user select a window... */
    while ((buttons == 0)) 
    {
	XtAppNextEvent(wmGD.mwmAppContext, &event);
	
	switch (event.type) 
	{
	  case ButtonPress:
	    if (target_win == None) 
	    {
		target_win = event.xbutton.subwindow; /* window selected */
		if (target_win == None)
		    target_win = RootWindow (wmGD.display, screen);
	    }
	    buttons++;
	    break;
	  case KeyPress:
	    /* Look for ESC key press and stop if we get one */
	    if (event.xkey.state & ShiftMask)
		offset = 1;
	    else
		offset = 0;
	    
	    keySym = XLookupKeysym((XKeyEvent *)&event, offset);
	    if (keySym == XK_Escape)
	    {
		buttons++;
		break;
	    }
        }
	
	XtDispatchEvent(&event);
    } 
    XUngrabKeyboard (wmGD.display, CurrentTime);      /* Done with keyboard */
    XUngrabPointer (wmGD.display, CurrentTime);      /* Done with pointer */
    pSD=wmGD.pActiveSD;
    
#ifdef  DEBUGGER
    printf("RootWindow (wmGD.display, screen) = %ld\n", RootWindow (wmGD.display, screen));
    printf("event.xbutton.root       = %ld\n", event.xbutton.root);
    printf("event.xbutton.window     = %ld\n", event.xbutton.window);
    printf("event.xbutton.subwindow  = %ld\n", event.xbutton.subwindow);
    printf("event.xbutton.x          = %d\n",  event.xbutton.x);
    printf("event.xbutton.y          = %d\n",  event.xbutton.y);
    printf("event.xbutton.x_root     = %d\n",  event.xbutton.x_root);
    printf("event.xbutton.y_root     = %d\n",  event.xbutton.y_root);
#endif  /*  DEBUGGER  */
    
    if (target_win == RootWindow (wmGD.display, screen))
     {
	title = GETMESSAGE(TSET, 120, "Workspace Selection Error");
	msg =  GETMESSAGE(TSET, 121, WKSPACE_SELECTION_MSG_1D);
	_DtMessage(XtParent(w), title, msg, NULL, NULL);

        return;
     }
    
    for (scr = 0; scr < wmGD.numScreens; scr++)
    {
	if (wmGD.Screens[scr].managed &&
	    wmGD.Screens[scr].screen == screen)
	{
	    pSD = (&(wmGD.Screens[scr]));
	    break;
	}
    }
    if (!pSD)
    {
	pSD=wmGD.pActiveSD;
    }

    /* check for subwindows */
    parent = RootWindow (wmGD.display, screen);
    x      = event.xbutton.x_root;
    y      = event.xbutton.y_root;
    
    /*
     * Determine if the top-level window that contains the pointer is a
     * client managed by the window manager (there may be no window under
     * the pointer or it may be an "override-redirect" window).
     */

    if ((event.xbutton.subwindow == None) ||
	(XFindContext (DISPLAY, event.xbutton.subwindow, wmGD.windowContextType,
	     (caddr_t *)&pCD)))
    {
	/* no managed window under the pointer */
	pCD = NULL;
	while (!foundOne) 
	{
	    XTranslateCoordinates(wmGD.display, parent, target_win, x, y,
				  &new_x, &new_y, &sub);
	    if (!sub) 
	    {
		x = new_x;
		y = new_y;
		break;
	    }
	    else 
	    {
		pECD = (WmFpEmbeddedClientData *) pSD->pECD;
		for (clientNum = 0; clientNum < pSD->numEmbeddedClients;
		     clientNum++, pECD++)
		{
		    if ((pECD->pCD) &&
			(target_win == pECD->pCD->client))
		    {
			pCD = pECD->pCD;
			foundOne = True;
			break;
		    }
		}


		parent = target_win;
		target_win = sub;
		x = new_x;
		y = new_y;
	    }
	}
    }

    strcpy(lbuild_title,
	GETMESSAGE(TSET, 42, "Workspace Manager: Change Input IL"));
    strcpy(lbuild_name,
	GETMESSAGE(TSET, 43, "Window:"));
    strcat(lbuild_name, " ");
    if(pCD){

	client_window = pCD->client;
        strcat(lbuild_name, pCD->clientName);
    }else{

	client_window = target_win;
        strcat(lbuild_name,
	    GETMESSAGE(TSET, 44, "Unmanaged Window"));
    }

    XTSOLgetResAttributes(DISPLAY, client_window, IsWindow, &resattr);
    User = (WmUser *)WmGetUserByUID(resattr.uid);
    if(strstr(User->u->labelview, TSOL_USER_VIEW_EXTERNAL_KW))
	labelview = LBUILD_VIEW_EXTERNAL;
    else
	labelview = LBUILD_VIEW_INTERNAL;
    billow(&min_iil);

    if (!iil_builder)
        create_change_iil_shell(wmGD.topLevelW1);

       /* user runs in the Multi level session */
       tsol_lbuild_set(iil_builder,
   	   LBUILD_SHOW,            TRUE,
	   LBUILD_LOWER_BOUND,	    &min_iil,
	   LBUILD_UPPER_BOUND,	    &resattr.sl,
           LBUILD_TITLE,	    lbuild_title,
           LBUILD_USERFIELD,	    lbuild_name,
	   LBUILD_VALUE_IL,         &resattr.iil,
	   LBUILD_VIEW,             labelview,
	   NULL);

  /* Make other ws buttons unsensitive, so user cannot launch another
   * Change SL dialog while working on the first one.
   */
 
   switch_data = panel.box_data[0]->switch_data;
   for (i=0; i < switch_data->switch_count; i++)
    {
     XtSetSensitive(switch_data->buttons[i],False);
    }


}
/*************************************<->*************************************
 *
 *  ShowLabelFeedbackWindow(pSD, string, xcolor)
 *
 *
 *  Description:
 *  -----------
 *  Pop up the window for moving and sizing feedback
 *
 *
 *  Inputs:
 *  ------
 *  pSD		- pointer to screen data
 *  string	- XmString of label to display
 *  xcolor	- XColor of label to display
 *  
 * 
 *  Outputs:
 *  -------
 *
 *
 *  Comments:
 *  --------
 *************************************<->***********************************/
#define FB_LABEL (1L << 2)
#define FEEDBACK_BEVEL             2

#ifdef _NO_PROTO
void ShowLabelFeedbackWindow (pSD, string, xcolor)
    
    WmScreenData *pSD;
    XmString string;
    XColor   xcolor;
#else /* _NO_PROTO */
void ShowLabelFeedbackWindow (WmScreenData *pSD, XmString string, Xcolor xcolor)
#endif /* _NO_PROTO */
{
    unsigned long        mask = 0;
    XSetWindowAttributes win_attribs;
    XWindowChanges       win_changes;
    int                  winX, winY;
    Dimension		width, height;

    /*
	check if same string as before
	copy and compare
     */

    if((lastlabel) && (XmStringCompare(lastlabel, string)))
	    return;
    if(lastlabel)
	    XmStringFree(lastlabel);
    lastlabel= XmStringCopy(string);

    /*
     * Derive the size and position of the window from the text extents
     * Set starting position of each string 
     */
    
    XmStringExtent(pSD->clientAppearance.fontList, string, &width, &height);

    pSD->fbStyle = FB_LABEL;

    pSD->fbWinHeight = height + 4*FEEDBACK_BEVEL;
    pSD->fbWinWidth = width + 4*FEEDBACK_BEVEL;

	pSD->fbLocY = 2*FEEDBACK_BEVEL;
	pSD->fbSizeY = pSD->fbLocY + height;
	pSD->fbLocX = 2*FEEDBACK_BEVEL;

	winX = (DisplayWidth(DISPLAY, pSD->screen) - pSD->fbWinWidth)/2;
	winY = (DisplayHeight(DISPLAY, pSD->screen) -pSD->fbWinHeight)/2;

    /*
     * bevel the window border for a 3-D look
     */
    if ( (pSD->fbTop && pSD->fbBottom) ||
	 (((pSD->fbTop = (RList*)AllocateRList((unsigned)2*FEEDBACK_BEVEL))!=(RList*)NULL)
	  &&
	  ((pSD->fbBottom = (RList*)AllocateRList((unsigned)2*FEEDBACK_BEVEL))!=(RList*)NULL)) )
    {
	pSD->fbTop->used = 0;
	pSD->fbBottom->used = 0;
	BevelRectangle (pSD->fbTop,
			pSD->fbBottom,
			0, 0, 
			pSD->fbWinWidth, pSD->fbWinHeight,
			FEEDBACK_BEVEL, FEEDBACK_BEVEL,
			FEEDBACK_BEVEL, FEEDBACK_BEVEL);
    }

    /*
     * Create window if not yet created, otherwise fix size and position
     */

    if (!pSD->feedbackWin)
    {

	/*
	 * Create the window
	 */

	mask = CWEventMask | CWOverrideRedirect | CWSaveUnder;
	win_attribs.event_mask = ExposureMask;
	win_attribs.override_redirect = TRUE;
	win_attribs.save_under = TRUE;

	/* 
	 * Use background pixmap if one is specified, otherwise set the
	 * appropriate background color. 
	 */

	if (pSD->feedbackAppearance.backgroundPixmap)
	{
	    mask |= CWBackPixmap;
	    win_attribs.background_pixmap =
				pSD->feedbackAppearance.backgroundPixmap;
	}
	else
	{
	    mask |= CWBackPixel;
	    win_attribs.background_pixel =
				pSD->feedbackAppearance.background;
	}

	pSD->feedbackWin = XCreateWindow (DISPLAY, pSD->rootWindow, 
					  winX, winY,
					  pSD->fbWinWidth, 
					  pSD->fbWinHeight,
					  0, CopyFromParent, 
					  InputOutput, CopyFromParent, 
					  mask, &win_attribs);
    }
    else
    {
	win_changes.x = winX;
	win_changes.y = winY;
	win_changes.width = pSD->fbWinWidth;
	win_changes.height = pSD->fbWinHeight;
	win_changes.stack_mode = Above;

	mask = CWX | CWY | CWWidth | CWHeight | CWStackMode;

	XConfigureWindow(DISPLAY, pSD->feedbackWin, (unsigned int) mask, 
	    &win_changes);
    }


    /*
     * Make the feedback window visible (map it)
     */

    if (pSD->feedbackWin)
    {
	/* Make sure the feedback window doesn't get buried */
	XRaiseWindow(DISPLAY, pSD->feedbackWin);
	XMapWindow (DISPLAY, pSD->feedbackWin);
	PaintLabelFeedbackWindow(pSD, string, xcolor);
    }

} /* END OF FUNCTION ShowLabelFeedbackWindow */



/*************************************<->*************************************
 *
 *  PaintLabelFeedbackWindow(pSD, string, xcolor)
 *
 *
 *  Description:
 *  -----------
 *  Repaints the feedback window in response to exposure events
 *
 *
 *  Inputs:
 *  ------
 *  pSD		- pointer to screen data
 * 
 *  Outputs:
 *  -------
 *
 *
 *  Comments:
 *  --------
 *************************************<->***********************************/
#ifdef _NO_PROTO
void PaintLabelFeedbackWindow (pSD, string, xcolor)

    WmScreenData *pSD;
    XmString	string;
    XColor	xcolor;
#else /* _NO_PROTO */
void PaintLabelFeedbackWindow (WmScreenData *pSD, XmString string, XColor xcolor)
#endif /* _NO_PROTO */
{
#define FUDGE_X	4
    static GC labelGC = 0;
    unsigned long valuemask;
    XGCValues values;
    extern Pixel	contrast(XColor);

    if (pSD->feedbackWin)
    {
	XRectangle pbox;

	pbox.x = 0;
	pbox.y = 0;
	pbox.width = pSD->fbWinWidth;
	pbox.height = pSD->fbWinHeight;
	/* 
	 * draw beveling 
	 */
	if (pSD->fbTop->used > 0) 
	{
	    XFillRectangles (DISPLAY, pSD->feedbackWin, 
			     pSD->feedbackAppearance.inactiveTopShadowGC,
			     pSD->fbTop->prect, pSD->fbTop->used);
	}
	if (pSD->fbBottom->used > 0) 
	{
	    XFillRectangles (DISPLAY, pSD->feedbackWin, 
			     pSD->feedbackAppearance.inactiveBottomShadowGC,
			     pSD->fbBottom->prect, 
			     pSD->fbBottom->used);
	}

	/*
	 * clear old text 
	 */
	XClearArea (DISPLAY, pSD->feedbackWin, 
		    FEEDBACK_BEVEL, FEEDBACK_BEVEL,
		    pSD->fbWinWidth-2*FEEDBACK_BEVEL, 
		    pSD->fbWinHeight-2*FEEDBACK_BEVEL,
		    FALSE);

	if (labelGC == 0){
	    labelGC = XCreateGC (DISPLAY, pSD->feedbackWin, 0, 0);
	    XCopyGC(DISPLAY, pSD->feedbackAppearance.inactiveGC, 0, labelGC);
	}
	values.background = xcolor.pixel;
	values.foreground = contrast(xcolor);
	valuemask = GCForeground | GCBackground;
	XChangeGC(DISPLAY, labelGC, valuemask, &values);


	/*
	 * put up new text
	 */
	    WmDrawXmString (DISPLAY, pSD->feedbackWin, 
			 pSD->clientAppearance.fontList,
			 string,
			 labelGC,
			 pSD->fbLocX - FUDGE_X, pSD->fbLocY, 
			 pSD->fbWinWidth, &pbox);
    }
}

/*--------------------------------------------------------------------
 * ChangePasswdCB - callback to exec tsolcpagent, which pops up a dialog
 *		    box and prompts user to change passwd
 */
#ifdef _NO_PROTO
void
ChangePasswdCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;
#else
void
ChangePasswdCB    (Widget    w,
                   XtPointer client_data,
	           XtPointer call_data)
#endif /* _NO_PROTO */
{
    int pid;                            /* process ID */
    char msg[2*BUFSIZ];                 /* working buffer */
    int status;                         /* status of wait */
    char* argv[4];
 
    /* tsolcpagent prog needs the progname, usrname and uid
     * as arguments. So create the argv.
     */
     sprintf(msg,"%d",ACTIVE_WS->User->p.pw_uid);
     argv[0] = strdup("tsolcpagent");
     argv[1] = strdup((char*)ACTIVE_WS->User->p.pw_name);
     argv[2] = msg;
     argv[3] = '\0';

    /*
     * fork and exec password process
     */
    if (!(pid = (int )fork())) {        /* I am the child */
	bclabel_t	new_proc_label;

	    bcllow(&new_proc_label);
	    setcmwplabel( &new_proc_label , SETCL_ALL);

        if ((execv ("/usr/dt/bin/tsolcpagent", argv)) == -1){
	    exit;
        }
 
    } /* else, I am the parent */
 
    if (pid == (-1)) { /* fork failed */
        sprintf(msg,"execit: fork failed for tsolcpagent");
        perror(msg);
        _DtMessage(wmGD.topLevelW1,"Fork Error",msg,NULL,NULL);
    }
}


/*--------------------------------------------------------------------
 * AllocateDeviceCB - callback to start Device Manager
 */
#ifdef _NO_PROTO
void
AllocateDeviceCB (w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;
#else
void
AllocateDeviceCB    (Widget    w,
                   XtPointer client_data,
	           XtPointer call_data)
#endif /* _NO_PROTO */
{
        WmFpPushRecallClientData *pPRCD;
        int j;
        WmScreenData *pSD = ACTIVE_PSD;

	WmFunction wm_func;
	int        function_index;
	String     func_arg = NULL;
	String     s1, s1save;
	char     * client_name;
	ClientData      * wm_client_data;
	WmPushRecallArg   push_argument;
	XmAnyCallbackStruct * callback;
	XEvent       * event;

	callback = (XmAnyCallbackStruct *) call_data;
	event = (XEvent *) callback->event;

        pPRCD = (WmFpPushRecallClientData *) pSD->pPRCD;

        for (j = 0; j < pSD->numPushRecallClients; j++, pPRCD++){
            if (!strcmp ("dtdevmgr",
                         (char *)(pPRCD->pchResName))) {

                  /*  Parse out the function and arguments used by the  */
                  /*  window manager to invoke the client.              */
                 
                  s1save = s1 = XtNewString ("f.action");

                  function_index =
                    ParseWmFunction ((unsigned char **) &s1, CRS_ANY, &wm_func);
                  XtFree (s1save);

                  client_name = "dtdevmgr";
                  s1 = XtNewString ("Dtdevmgr");
                  ParseWmFunctionArg ((unsigned char **) &s1, function_index,
                                      wm_func, (void **) &func_arg,
                                      client_name, client_name);

                  /*  Set the push argument to the parsed data  */

                  push_argument.ixReg = j;
                  push_argument.wmFunc = wm_func;
                  push_argument.pArgs = func_arg;
		  wm_client_data = NULL;
                  F_Push_Recall ((String) &push_argument,
                                 wm_client_data, callback->event);

                  FreeFunctionArg (wm_func, func_arg);
                  XtFree (s1);
               }
	}
}

#endif /* TSOL */
